The potential energy surface for Li3
------------------------------------
! The code provided here computes the PES for spin aligned Li3.  
! This Potential should be used for any scattering energies below 1.5eV. Zero energy is defined
! as the 2S+2S+2S three body dissociation limit.
!    Written by X. Li@University of Oklahoma
!    Supervisor: G. A. Parker
!    See Journal of Chemical Phyiscs 129. Page 124305 (2008)
!-----------------------------------

It construct 1A',2A', 1A'',2A'' surfaces 
USING V=V(DIM)+V(3body)


can be cited when using this code.

Questions/Comments to: LI@NHN.OU.EDU

list of vital files:
surface.f90    ------------main calling routine
All_MOT3.f90   ------------MODULE file
SPLINE.f90     ------------SPLINE codes
surface_1APP.f ------------calling routine for 1A'' surface
surface_2APP.f ------------calling routine for 2A'' surface
surface_1AP.f  ------------calling routine for 1A' surface
surface_2AP.f  ------------calling routine for 2A' surface
TRI3B_1APP.f   ------------Three body potential for 1A''
TRI3B_2APP.f   ------------Three body potential for 2A''
TRI3B_1AP.f    ------------Three body potential for 1A'
TRI3B_2AP.f    ------------Three body potential for 2A'
Vhamil_1AP.f90 ------------DIM potential for 1A'
Vhamil_2AP.f90 ------------DIM potential for 2A'
Vhamil_APP.f90 ------------DIM potential for 1A'' and 2A''
POT16.f90      ------------SPLINE for diatomic potentials
Umatrix_2.f90  ------------Transformation Matrix codes



!How to use
1. Set up two directories: "Potentials" "lib" if they don't exist in your main directory.
2. Download and move this WEB_LI3 directory to the "Potentials" directory.
3. Examine the Makefile in WEB_LI3 so that it fits your machine and compiler. 
4. Type "Make" and hit enter in the "Potentials/WEB_LI3" directory. It will create the libraty files to the ./lib directory.
5. Link the library in your own Makefile
6. The four potentials can be called by "call surface_1AP(v,rij)"  for the  1A' PES
                                        "call surface_2AP(v,rij)"  for the  2A' PES
                                        "call surface_1APP(v,rij)" for the  1A''PES
                                        "call surface_2APP(v,rij)" for the  2A''PES
   here, v is a double precision variable to output the potential, and rij is a dimension 3 vector as rij(3). Both of these dummy variables are in atomic units.

Good luck!

          XL

09-30-2008

      !-------------------------------------------------------------------
      ! function  : vli3_at
      !
      ! package   : Li3 Potential
      !
      ! Language  : Fortran 77
      !
      ! author    : F. Colavecchia (flavioc@lanl.gov)
      !           : G. A. Parker   (parker@phyast.nhn.ou.edu)
      !
      ! date      : 05/12/02
      ! revision  :
      !
      ! purpose   : compute Li3 Axilrod Teller term , eq. (14) of paper JCP 118 5484 (2003).
      !
      ! input     :    r    -> (dim=3) interatomic distances in bohr.
      !
      ! output    :    vli3_at -> li3 Axilrod Teller potential in a.u.  
      !
      !-------------------------------------------------------------------
      real*8 function vli3_at(r)
      implicit none
      !
      ! All distances in atomic units
      !
      real*8 r(3),cos1,cos2,cos3
      real*8 C,v,rp,coef,rp3,angfac
      parameter (coef=10000d0)
      
      vli3_at = 1.0d0/coef
      C = 170100d0
      cos1 = 0d0
      cos2 = 0d0
      cos3 = 0d0
      rp = r(1)*r(2)*r(3)
      rp3=rp**3
      if(rp.lt.1d-10) then
          if(abs(r(1)).lt.1d-10) cos1 = 1d0
          if(abs(r(2)).lt.1d-10) cos2 = 1d0
          if(abs(r(3)).lt.1d-10) cos3 = 1d0            
      else 
          cos1 = (r(2)**2+r(3)**2-r(1)**2)/(2*r(2)*r(3))
          cos2 = (r(1)**2+r(3)**2-r(2)**2)/(2*r(1)*r(3))
          cos3 = (r(2)**2+r(1)**2-r(3)**2)/(2*r(2)*r(1))
      end if

      
      angfac = (1d0+3d0*cos1*cos2*cos3)
      vli3_at=C/(coef*C+rp3)*angfac
      
      return
      end

      subroutine surface(v,rij)
        implicit none
!-----------------------------------------------------------------------
! This routine supplies the potential energy surface for the
! reactive scattering codes.
!
! On entering: The arrary rij contains the internuclear distances
!              in units of bohr (NOT mass scaled).
!
! On Exit:     The variable v is the value of the potential energy
!              surface in Hartree atomic units.
!
!
!-----------------------------------------------------------------------
      real*8 rij, v
      dimension rij(3)
      call surface1AP(v,rij)
      return
      end

SUBROUTINE surface_1AP(v,x)
!--------------------------------
! This Potential should be used for any scattering energies below 1.5eV. Zero energy is defined
! as the 2S+2S+2S three body dissociation limit.
!    Written by X. Li@University of Oklahoma
!    Supervisor: G. A. Parker
!    See Journal of Chemical Phyiscs 129. Page 124305 (2008)
!--------------------------------
IMPLICIT NONE
REAL*8 r(3),v,phi,x(3),phio,E(37),phiswitch
integer r2s
real*8 delper,s1switch,dphi,pswitch,s1,vli3_at,VF,temp,big
real*8 acos,tanh,v1,v2,v3b,vli2
data delper/0.075d0/
data pswitch/25d0/
data dphi/0.02d0/
data phio/2.96705972839036d0/ ! 170* degrees
data big/1d-10/
save

r(1)=maxval(x)
r(3)=minval(x)
r(2)=max(min(x(1),x(2)),min(x(2),x(3)),min(x(1),x(3)))
temp=(r(2)**2+r(3)**2-r(1)**2)/(2d0*r(2)*r(3))
IF(abs(temp-1d0).lt.1d-10)THEN
phi=acos(1d0)
ELSEIF(abs(temp+1d0).lt.1d-10)THEN
phi=acos(-1d0)
ELSE
phi=acos(temp)
ENDIF

!     No three-body fit at C_{iv} geometries
      phiswitch=0.5d0*(1.d0+tanh((phi-phio)/(phio*dphi)))
      call Vhamil_1AP_CIV(E,r)
      v1=E(1)

!     At C_{2v} geometries
      s1=(r(1)+r(2)+r(3))/dsqrt(3.0d0)
      s1switch=0.5d0*(1.d0+tanh((s1-pswitch)/(pswitch*delper)))
      call Vhamil_1AP_C2V(E,r)
      call TRI3B_1AP_C2V_3(r(1),r(2),r(3),v3b)
 
!     Make sure the highly repulsive wall is okay    
      IF(r(1).lt.4.0d0.and.E(1).gt.1d-2)THEN
      v3b=0d0
      ENDIF
  
      V2=E(1)+V3b*(1.d0-s1switch)
      v=v2*(1.d0-phiswitch)+v1*phiswitch

!     Make sure the asymptotic region is correct
      CALL vli3_F(R,VF)
      V=V*(1d0-s1switch)+VF*s1switch

return
END      

      

      integer function r2s(r1,r2,r3,s1,s2,s3,unsym)
      !
      ! For a given r1,r2,r3 this routine 
      ! gives s1,s2,s3 such that
      !
      ! 0 < s3 < s/(2*sqrt(6))
      ! 0 < s2 < s/(2*sqrt(2))
      ! 0 < s3 < sqrt(1/3) s2
      !
      ! So that (s2,s3) point lies in the
      ! region (1) defined in the notes.
      ! On output, the integer between 1 and 6
      ! indicates the region where the r1,r2,r3
      ! point was before the transformations.
      ! 
      implicit none
      integer i
      logical unsym
      real*8 s1,s2,s3,r1,r2,r3,s,q
      real*8 s1o,s2o,s3o
      logical debug
      data debug /.false./

      r2s = 0      
      q = dsqrt(1d0/3d0)
      s = r1+r2+r3
      s1o=(r1+r2+r3)/dsqrt(3.0d0)
      s2o=(r2-r3)/dsqrt(2.0d0)
      s3o=(2.0d0*r1-r2-r3)/dsqrt(6.0d0)

      s1 = s1o 
      s2 = s2o 
      s3 = s3o 

      if(unsym) return   ! return if we do not need to symmetrize

      if(s3o.ge.q*s2o.and.s3o.ge.-q*s2o ) then
!          if(s3.ge.-dsqrt(1d0/3d0)*s2) then
              if(s2o.ge.0d0) then
                  ! region 1
                  ! (123)->(123)                                    
                  i=1
              else
                  ! region 6
                  ! (23)->(32)                                    
                  i=6
                  s2=(r3-r2)/dsqrt(2.0d0)
              end if
      elseif(s3o.ge.q*s2o.and.s3o.lt.-q*s2o ) then
              ! region 5
              ! (123)->(312)                                
              i = 5              
              s2=(r1-r2)/dsqrt(2.0d0)
              s3=(2.0d0*r3-r1-r2)/dsqrt(6.0d0)
      elseif(s3o.lt.q*s2o.and.s3o.lt.-q*s2o ) then
              if(s2o.gt.0d0) then
                  ! region 3
                  ! (123)->(231)                  
                  i=3
                  s2=(r3-r1)/dsqrt(2.0d0)
                  s3=(2.0d0*r2-r3-r1)/dsqrt(6.0d0)                  
              else
                  ! region 4
                  i=4
                  ! (13)->(31)
                  s2=(r2-r1)/dsqrt(2.0d0)
                  s3=(2.0d0*r3-r2-r1)/dsqrt(6.0d0)                  
              end if
      elseif(s3o.lt.q*s2o.and.s3o.ge.-q*s2o) then
              ! region 2
              ! (12)->(21)
              i = 2              
              s2=(r1-r3)/dsqrt(2.0d0)
              s3=(2.0d0*r2-r1-r3)/dsqrt(6.0d0)
      end if
      if(debug) then
      write(*,'(a5,6f12.6,a16,i3)') 'Point',s1o,s2o,s3o,r1,r2,r3,
     $ ' lies in region ',i
      end if
      r2s = i
      
      return
      end      
      
      
      
      
      
      
      

      SUBROUTINE  AKIMA (NP,ND,XD,YD,NI,XI, YI)
C
C PREVIOUSLY THIS ROUTINE WAS CALLED UVIP3P AND WAS IN SINGLE PRECISION
C IT WAS DOWNLOADED FROM GAMS AT NIST ON OCT 21 1998 
C IT PROVIDES SLIGHTLY BETTER FITTING THAN THE IMSL ROUTINE DCSAKM
C THIS IS A SUBJECTIVE COMMENT - IT DOES HOWEVER PREVENT
C OSCILLATIONS BETWEEN SPARCE DATA POINTS
C
C Univariate Interpolation (Improved Akima Method)
C
C Hiroshi Akima
C U.S. Department of Commerce, NTIA/ITS
C Version of 89/07/04
C
C This subroutine performs univariate interpolation.  It is based
C on the improved A method developed by Hiroshi Akima, 'A method
C of univariate interpolation that has the accuracy of a third-
C degree polynomial,' ACM TOMS, vol. xx, pp. xxx-xxx, 19xx.  (The
C equation numbers referred to in the comments below are those in
C the paper.)
C
C In this method, the interpolating function is a piecewise
C function composed of a set of polynomials applicable to
C successive intervals of the given data points.  This method
C uses third-degree polynomials as the default, but the user has
C an option to use higher-degree polynomial to reduce undulations
C in resulting curves.
C
C This method has the accuracy of a third-degree polynomial if
C the degree of the polynomials for the interpolating function is
C set to three.
C
C The input arguments are
C   NP = degree of the polynomials for the interpolating
C        function,
C   ND = number of input data points
C        (must be equal to 2 or greater),
C   XD = array of dimension ND, containing the abscissas of
C        the input data points
C        (must be in a monotonic increasing order),
C   YD = array of dimension ND, containing the ordinates of
C        the input data points,
C   NI = number of points for which interpolation is desired
C        (must be equal to 1 or greater),
C   XI = array of dimension NI, containing the abscissas of
C        the desired points.
C
C The output argument is
C   YI = array of dimension NI, where the ordinates of the
C        desired points are to be stored.
C
C If an integer value smaller than 3 is given to the NP argument,
C this subroutine assumes NP = 3.
C
C The XI array elements need not be monotonic, but this
C subroutine interpolates faster if the XI array elements are
C given in a monotonic order.
C
C If the XI array element is less than XD(1) or greater than
C XD(ND), this subroutine linearly interpolates the YI value.
C
C
C Specification statement
      implicit real*8 (a-h,o-z)
      DIMENSION   XD(*),YD(*),XI(*), YI(*)
C Error check
   10 IF (ND.LE.1)   GO TO 90
      IF (NI.LE.0)   GO TO 91
      DO 11  ID=2,ND
        IF (XD(ID).LE.XD(ID-1))     GO TO 92
   11 CONTINUE
C Branches off special cases.
      IF (ND.LE.4)   GO TO 50
C General case  --  Five data points of more
C Calculates some local variables.
   20 NP0=MAX(3,NP)
      NPM1=NP0-1
      RENPM1=NPM1
      RENNM2=NP0*(NP0-2)
C Main calculation for the general case
C First (outermost) DO-loop with respect to the desired points
   30 DO 39  II=1,NI
        IF (II.EQ.1)      IINTPV=-1
        XII=XI(II)
C Locates the interval that includes the desired point by binary
C search.
        IF (XII.LE.XD(1))  THEN
          IINT=0
        ELSE IF (XII.LT.XD(ND))  THEN
          IDMN=1
          IDMX=ND
          IDMD=(IDMN+IDMX)/2
   31     IF (XII.GE.XD(IDMD))  THEN
            IDMN=IDMD
          ELSE
            IDMX=IDMD
          END IF
          IDMD=(IDMN+IDMX)/2
          IF (IDMD.GT.IDMN)    GO TO 31
          IINT=IDMD
        ELSE
          IINT=ND
        END IF
C End of locating the interval of interest
C Interpolation or extrapolation in one of the three subcases
        IF (IINT.LE.0)  THEN
C Subcase 1  --  Linear extrapolation when the abscissa of the
C                desired point is equal to that of the first data
C                point or less.
C Estimates the first derivative when the interval is not the
C same as the one for the previous desired point.  --
C cf. Equation (8)
          IF (IINT.NE.IINTPV)  THEN
            IINTPV=IINT
            X0=XD(1)
            X1=XD(2)-X0
            X2=XD(3)-X0
            X3=XD(4)-X0
            Y0=YD(1)
            Y1=YD(2)-Y0
            Y2=YD(3)-Y0
            Y3=YD(4)-Y0
            DLT=X1*X2*X3*(X2-X1)*(X3-X2)*(X3-X1)
            A1=(((X2*X3)**2)*(X3-X2)*Y1
     1         +((X3*X1)**2)*(X1-X3)*Y2
     2         +((X1*X2)**2)*(X2-X1)*Y3)/DLT
          END IF
C Evaluates the YI value.
          YI(II)=Y0+A1*(XII-X0)
C End of Subcase 1
        ELSE IF (IINT.GE.ND)  THEN
C Subcase 2  --  Linear extrapolation when the abscissa of the
C                desired point is equal to that of the last data
C                point or greater.
C Estimates the first derivative when the interval is not the
C same as the one for the previous desired point.  --
C cf. Equation (8)
          IF (IINT.NE.IINTPV)  THEN
            IINTPV=IINT
            X0=XD(ND)
            X1=XD(ND-1)-X0
            X2=XD(ND-2)-X0
            X3=XD(ND-3)-X0
            Y0=YD(ND)
            Y1=YD(ND-1)-Y0
            Y2=YD(ND-2)-Y0
            Y3=YD(ND-3)-Y0
            DLT=X1*X2*X3*(X2-X1)*(X3-X2)*(X3-X1)
            A1=(((X2*X3)**2)*(X3-X2)*Y1
     1         +((X3*X1)**2)*(X1-X3)*Y2
     2         +((X1*X2)**2)*(X2-X1)*Y3)/DLT
          END IF
C Evaluates the YI value.
          YI(II)=Y0+A1*(XII-X0)
C End of Subcase 2
        ELSE
C Subcase 3  --  Interpolation when the abscissa of the desired
C                point is  between those of the first and last
C                data points.
C Calculates the coefficients of the third-degree polynomial (for
C NP.LE.3) or the factors for the higher-degree polynomials (for
C NP.GT.3), when the interval is not the same as the one for the
C previous desired point.
          IF (IINT.NE.IINTPV)  THEN
            IINTPV=IINT
C The second DO-loop with respect to the two endpoints of the
C interval
            DO 37  IEPT=1,2
C Calculates the estimate of the first derivative at an endpoint.
C Initial setting for calculation
              ID0=IINT+IEPT-1
              X0=XD(ID0)
              Y0=YD(ID0)
              SMPEF=0.0d0
              SMWTF=0.0d0
              SMPEI=0.0d0
              SMWTI=0.0d0
C The third (innermost) DO-loop with respect to the four primary
C estimate of the first derivative
              DO 36  IPE=1,4
C Selects point numbers of four consecutive data points for
C calculating the primary estimate of the first derivative.
                IF (IPE.EQ.1)  THEN
                  ID1=ID0-3
                  ID2=ID0-2
                  ID3=ID0-1
                ELSE IF (IPE.EQ.2)  THEN
                  ID1=ID0+1
                ELSE IF (IPE.EQ.3)  THEN
                  ID2=ID0+2
                ELSE
                  ID3=ID0+3
                END IF
C Checks if any point number falls outside the legitimate range
C (between 1 and ND).  Skips calculation of the primary estimate
C if any does.
                IF (ID1.LT.1.OR.ID2.LT.1.OR.ID3.LT.1.OR.
     1              ID1.GT.ND.OR.ID2.GT.ND.OR.ID3.GT.ND)
     2               GO TO 36
C Calculates the primary estimate of the first derivative  --
C cf. Equation (8)
                X1=XD(ID1)-X0
                X2=XD(ID2)-X0
                X3=XD(ID3)-X0
                Y1=YD(ID1)-Y0
                Y2=YD(ID2)-Y0
                Y3=YD(ID3)-Y0
                DLT=X1*X2*X3*(X2-X1)*(X3-X2)*(X3-X1)
                PE=(((X2*X3)**2)*(X3-X2)*Y1
     1             +((X3*X1)**2)*(X1-X3)*Y2
     2             +((X1*X2)**2)*(X2-X1)*Y3)/DLT
C Calculates the volatility factor, VOL, and distance factor,
C SXX, for the primary estimate.  --  cf. Equations (9) and (11)
                SX=X1+X2+X3
                SY=Y1+Y2+Y3
                SXX=X1*X1+X2*X2+X3*X3
                SXY=X1*Y1+X2*Y2+X3*Y3
                DNM=4.0d0*SXX-SX*SX
                B0=(SXX*SY-SX*SXY)/DNM
                B1=(4.0d0*SXY-SX*SY)/DNM
                DY0=-B0
                DY1=Y1-(B0+B1*X1)
                DY2=Y2-(B0+B1*X2)
                DY3=Y3-(B0+B1*X3)
                VOL=DY0*DY0+DY1*DY1+DY2*DY2+DY3*DY3
C Calculates the EPSLN value, which is used to decide whether or
C not the volatility factor, VOL, is essentially zero.
                EPSLN=(YD(ID0)**2+YD(ID1)**2
     1                +YD(ID2)**2+YD(ID3)**2)*1.0D-12
C Accumulates the weighted primary estimates.  --
C cf. Equations (13) and (14)
                IF (VOL.GT.EPSLN)  THEN
C - For finite weight.
                  WT=1.0d0/(VOL*SXX)
                  SMPEF=SMPEF+PE*WT
                  SMWTF=SMWTF+WT
                ELSE
C - For infinite weight.
                  SMPEI=SMPEI+PE
                  SMWTI=SMWTI+1.0d0
                END IF
   36         CONTINUE
C End of the third DO-loop
C Calculates the final estimate of the first derivative.  --
C cf. Equation (14)
              IF (SMWTI.LT.0.5d0)  THEN
C - When no infinite weights exist.
                YP=SMPEF/SMWTF
              ELSE
C - When infinite weights exist.
                YP=SMPEI/SMWTI
              END IF
              IF (IEPT.EQ.1)  THEN
                YP0=YP
              ELSE
                YP1=YP
              END IF
C End of the calculation of the estimate of the first derivative
C at an endpoint
   37       CONTINUE
C End of the second DO-loop
            IF (NP0.LE.3)  THEN
C Calculates the coefficients of the third-degree polynomial
C (when NP.LE.3).  --  cf. Equation (4)
              DX=XD(IINT+1)-XD(IINT)
              DY=YD(IINT+1)-YD(IINT)
              A0=YD(IINT)
              A1=YP0
              YP1=YP1-YP0
              YP0=YP0-DY/DX
              A2=-(3.0d0*YP0+YP1)/DX
              A3= (2.0d0*YP0+YP1)/(DX*DX)
            ELSE
C Calculates the factors for the higher-degree polynomials
C (when NP.GT.3).  --  cf. Equation (20)
              DX=XD(IINT+1)-XD(IINT)
              DY=YD(IINT+1)-YD(IINT)
              T0=YP0*DX-DY
              T1=YP1*DX-DY
              AA0= (T0+RENPM1*T1)/RENNM2
              AA1=-(RENPM1*T0+T1)/RENNM2
            END IF
          END IF
C End of the calculation of the coefficients of the third-degree
C polynomial (when NP.LE.3) or the factors for the higher-degree
C polynomials (when NP.GT.3), when the interval is not the same
C as the one for the previous desired point.
C Evaluates the YI value.
          IF (NP0.LE.3)  THEN
C - With a third-degree polynomial.  --  cf. Equation (3)
            XX=XII-XD(IINT)
            YI(II)=A0+XX*(A1+XX*(A2+XX*A3))
          ELSE
C - With a higher-degree polynomial.  --  cf. Equation (19)
            U=(XII-XD(IINT))/DX
            UC=1.0d0-U
            V=AA0*((U**NP0)-U)+AA1*((UC**NP0)-UC)
            YI(II)=YD(IINT)+DY*U+V
          END IF
C End of Subcase 3
        END IF
   39 CONTINUE
C End of the first DO-loop
C End of general case
      RETURN
C Special cases  --  Four data points or less
C Preliminary processing for the special cases
   50 X0=XD(1)
      Y0=YD(1)
      X1=XD(2)-X0
      Y1=YD(2)-Y0
      IF (ND.EQ.2)   GO TO 60
      X2=XD(3)-X0
      Y2=YD(3)-Y0
      IF (ND.EQ.3)   GO TO 70
      X3=XD(4)-X0
      Y3=YD(4)-Y0
      GO TO 80
C Special Case 1  --  Two data points
C (Linear interpolation and extrapolation)
   60 A1=Y1/X1
      DO 61  II=1,NI
        YI(II)=Y0+A1*(XI(II)-X0)
   61 CONTINUE
C End of Special Case 1
      RETURN
C Special Case 2  --  Three data points
C (Quadratic interpolation and linear extrapolation)
   70 DLT=X1*X2*(X2-X1)
      A1=(X2*X2*Y1-X1*X1*Y2)/DLT
      A2=(X1*Y2-X2*Y1)/DLT
      A12=2.0d0*A2*X2+A1
      DO 71  II=1,NI
        XX=XI(II)-X0
        IF (XX.LE.0.0d0)  THEN
          YI(II)=Y0+A1*XX
        ELSE IF (XX.LT.X2) THEN
          YI(II)=Y0+XX*(A1+XX*A2)
        ELSE
          YI(II)=Y0+Y2+A12*(XX-X2)
        END IF
   71 CONTINUE
C End of Special Case 2
      RETURN
C Special Case 3  --  Four data points
C (Cubic interpolation and linear extrapolation)
   80 DLT=X1*X2*X3*(X2-X1)*(X3-X2)*(X3-X1)
      A1=(((X2*X3)**2)*(X3-X2)*Y1
     1   +((X3*X1)**2)*(X1-X3)*Y2
     2   +((X1*X2)**2)*(X2-X1)*Y3)/DLT
      A2=(X2*X3*(X2*X2-X3*X3)*Y1
     1   +X3*X1*(X3*X3-X1*X1)*Y2
     2   +X1*X2*(X1*X1-X2*X2)*Y3)/DLT
      A3=(X2*X3*(X3-X2)*Y1
     1   +X3*X1*(X1-X3)*Y2
     2   +X1*X2*(X2-X1)*Y3)/DLT
      A13=(3.0d0*A3*X3+2.0d0*A2)*X3+A1
      DO 81  II=1,NI
        XX=XI(II)-X0
        IF (XX.LE.0.0d0)  THEN
          YI(II)=Y0+A1*XX
        ELSE IF (XX.LT.X3) THEN
          YI(II)=Y0+XX*(A1+XX*(A2+XX*A3))
        ELSE
          YI(II)=Y0+Y3+A13*(XX-X3)
        END IF
   81 CONTINUE
C End of Special Case 3
      RETURN
C Error exit
   90 WRITE (*,99090) ND
      GO TO 99
   91 WRITE (*,99091) NI
      GO TO 99
   92 WRITE (*,99092) ID,XD(ID-1),XD(ID)
   99 WRITE (*,99099)
      RETURN
C Format statements for error messages
99090 FORMAT (1X/ ' ***   Insufficient data points.'
     1  7X,'ND =',I3)
99091 FORMAT (1X/ ' ***   No desired points.'
     1  7X,'NI =',I3)
99092 FORMAT (1X/ ' ***   Two data points identical or out of ',
     1  'sequence.'/
     2  7X,'ID, XD(ID-1), XD(ID) =',I5,2F10.3)
99099 FORMAT (' Error detected in the akima subroutine'/)
      END
      !-------------------------------------------------------------------
      ! subroutine: mpot
      !
      ! package   : li3 Potentials
      !
      ! Language  : Fortran 77
      !
      ! author    : V. Venturi (vanessa.venturi@nist.gov)
      !
      ! revision  : F. Colavecchia (flavioc@lanl.gov)
      !
      ! purpose   :  Get the potential of the singlet and triplet Li2,
      !             once the data and parameters are read at syspot3;
      !             according to eq. (8) of  JCP 118 5484 (2003).
      !
      ! input     :   np -> degree of polynomial used in the akima interpolation. 
      !            ndata -> number of ab initio+rkr+exchange data points
      !            rdata -> distance in a.u. for each data point
      !            vdata -> potentials at each data point.
      !            c6    -> data for Van der Waals form, eq. (3)
      !            c8    -> data for Van der Waals form, eq. (3)
      !            c10   -> data for Van der Waals form, eq. (3) 
      !            cA    -> data for exchange form, eq. (6)
      !            beta  -> data for exchange form, eq. (6)
      !            gamma -> data for exchange form, eq. (6)
      !            a     -> data for short range form, eq. (7)
      !            b     -> data for short range form, eq. (7)
      !            nv    -> singlet (nv=1) or triplet (nv=2) potential
      !            r     -> internuclear distance in a.u.                   
      !
      ! output    :    v -> li2 potential in a.u.
      !
      !
      ! notes     : The original code included RKR data from table 3
      !             (Linton et al J. Mol. Spect. 196, 20 (1999)).
      !             Now we make use of new RKR data provided by A. Ross
      !             (ross@in2p3.fr), read from rkr.dat. See also
      !             readme_li2.txt for the values of De, Do, a, rmin.
      !             Comments noted by CFC were included by F. Colavecchia
      !
      !-------------------------------------------------------------------
      subroutine mpot(np,ndata,rdata,vdata,c6,c8,c10,
     >                CA,beta,gamma,a,b,nv,r,v)
C
      double precision rdata,vdata,c6,c8,c10,CA,beta,gamma,a,b,r,v
      integer  np,ndata,nv
      dimension rdata(ndata),vdata(ndata)
C
C ... Local Variables
C  
      double precision vex,vdisp,rfinal

      rfinal = rdata(ndata)
C
      if(r.ge.0.0d0 .and. r.lt.rdata(1)) then
          !
          !     Extrapolate short range data using the form: aexp(-br)
          !	
          v=a*exp(-b*r)         
      elseif(r.ge.rdata(1) .and. r.lt.rfinal) then
          !
          !     Interpolate short range data 
          !	
          call akima(np,ndata,rdata,vdata,1,r,v)
          v=v/r**6 
      elseif(r.ge.rfinal) then
          !
          !     Calculate long range form
          !
          vex=CA*exp(-beta*r)*r**gamma 
          vdisp=-c6/r**6-c8/r**8-c10/r**10
          if(nv.eq.1) then
            v=vdisp-vex
          elseif(nv.eq.2) then
              v=vdisp+vex
          endif  
          
      endif 
C
      return
      end 
      !-------------------------------------------------------------------
      ! function  : correction_ss
      !
      ! package   : li3 Potentials
      !
      ! Language  : Fortran 77
      !
      ! author    : V. Venturi (vanessa.venturi@nist.gov)
      !
      ! revision  : F. Colavecchia (flavioc@lanl.gov)
      !
      ! purpose   : Harmonic correction for the potential.
      !
      !
      ! input     :    r    -> interatomic distance in bohr.
      !               shift -> harmonic constant of the correction
      !                re   -> distance at the minimum of the potential
      !
      ! output    :    v -> correction potential
      !
      !-------------------------------------------------------------------      
      double precision function correction_ss(r,shift,re)
      implicit none
      double precision r,shift,c6,re

      correction_ss=0.0d0
      if (r.lt.re) correction_ss=shift*(r-re)**2

      return
      end
      !-------------------------------------------------------------------
      ! function  : sort
      !
      ! package   : li3 Potentials
      !
      ! Language  : Fortran 77
      !
      ! author    : V. Venturi (vanessa.venturi@nist.gov)
      !
      ! purpose   : sorting vector a and b in ascending order
      !-------------------------------------------------------------------      
      subroutine sort(a,b,n)
      implicit none
      integer n,i,j
      real*8 a(n),atem,b(n),btem
      do 10 j=1,n
         do 20 i=1,n-j
            if (a(i).gt.a(i+1)) then
               atem=a(i+1)
               a(i+1)=a(i)
               a(i)=atem
               btem=b(i+1)
               b(i+1)=b(i)
               b(i)=btem
            end if
20       continue
10    continue
      return
      end
      !-------------------------------------------------------------------
      ! function  : sort
      !
      ! package   : li3 Potentials
      !
      ! Language  : Fortran 77
      !
      ! author    : V. Venturi (vanessa.venturi@nist.gov)
      !
      ! purpose   : sorting vector a,b and c in ascending order
      !-------------------------------------------------------------------      
      subroutine sort2(a,b,c,n)
      implicit none
      integer n,i,j
      real*8 a(n),atem,b(n),btem,c(n),ctem
      do 10 j=1,n
         do 20 i=1,n-j
            if (a(i).gt.a(i+1)) then
               atem=a(i+1)
               a(i+1)=a(i)
               a(i)=atem
               btem=b(i+1)
               b(i+1)=b(i)
               b(i)=btem
               ctem=c(i+1)
               c(i+1)=c(i)
               c(i)=ctem
            end if
20       continue
10    continue
      return
      end
    !-------------------------------------------------------------------
    ! function  : syspot2
    !
    ! package   : li3 Potentials
    !
    ! Language  : Fortran 77
    !
    ! author    : V. Venturi (vanessa.venturi@nist.gov)
    !
    ! revision  : F. Colavecchia (flavioc@lanl.gov) 
    !
    ! purpose   :  Get the potential of the singlet and triplet Li2.
    !
    !
    ! input     :    r    -> interatomic distance in bohr.
    !               nv    -> singlet (nv=1) or triplet (nv=2) potential
    !              lsetup -> sets up the reading of data or calculation
    !                        of potential
    !
    ! output    :    v -> li2 potential in a.u.  
    !             
    !
    ! modules   :
    !
    ! common    :
    !
    ! notes     : The original code included RKR data from table 3
    !             (Linton et al J. Mol. Spect. 196, 20 (1999)).
    !             Now we make use of new RKR data provided by A. Ross
    !             (ross@in2p3.fr), read from rkr.dat. See also
    !             readme_li2.txt for the values of De, Do, a, rmin.
    !             Comments noted by CFC were included by F. Colavecchia
    !
    !-------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION SYS_SS_pot_3(R,V,NV,LSETUP)
      IMPLICIT NONE
      DOUBLE PRECISION R,V
      INTEGER NV
      LOGICAL LSETUP
C
C ... Local Variables
C
      double precision c6,c8,c10,CA,beta,gamma,as,bs,at,bt,
     >  re1,re3,shift1,shift3,rdatas,vdatas,rdatat,vdatat
      save c6,c8,c10,CA,beta,gamma,as,bs,at,bt,
     >  re1,re3,shift1,shift3,rdatas,vdatas,rdatat,vdatat
      double precision hartree,bohra
      save  hartree,bohra
      double precision correction_ss
      double precision rs1,vs1,rs2,vs2,rs3,vs3,rt0,vt0,rt1,vt1,rt2,vt2,
     >  rt3,vt3,res,des,ret,det,rdat,vdats,vdatt
      double precision  vs,vt,vav,vdiff,vex,vdisp,amp,vshift,
     >  rfit,rjoin,rfinal,r0,rl,ri,r1,r2,v1,v2,delta
      
      integer np,ns,nt,ndatas,ndatat
      save np,ns,nt,ndatas,ndatat
      integer  i,j,k,ni,nsl,ntl,ndat,nt2off
C
      integer  ns1,ns2,ns3,nt1,nt2,nt3,nt0
      integer nmax
      parameter (nmax=500)
      
      parameter (ns1=3,ns2=42,ns3=41,nt1=11,nt0=11,nt2=27,nt3=26)
      
C
      real*8 vdatatp(nmax),vdatasp(nmax)
      dimension rs1(ns1),vs1(ns1),rs2(ns2),vs2(ns2),rs3(ns3),vs3(ns3),
     >  rt1(nt1),vt1(nt1),rt2(nt2),vt2(nt2),rt3(nt3),vt3(nt3)
      dimension rdatas(nmax),vdatas(nmax),rdatat(nmax),vdatat(nmax),
     >  rdat(nmax),vdats(nmax),vdatt(nmax)
      dimension vt0(nt0),rt0(nt0)
      logical do_setup
      data do_setup /.true./
      save  do_setup
      logical order,norepeat
C
C     output flags for potential routine:
C     output_data  - output raw potential data
C     output_fitex - exchange fitting constant A as a function of R 
C     output_v     - output final potentials to be used in calculations
C     output_vmesh - output interpolated mesh of final potentials +
C                    correction included
C
      logical  output_data, output_fitex, output_v, output_vmesh
      data output_data /.false./
      data output_fitex /.false./
      data output_v /.false./
      data output_vmesh /.false./
C
C=====Data for ^7Li2====================================================
C
C     Physical constants used in potential routines
C
      DATA HARTREE /219474.630680D0/, BOHRA /0.5291772490D0/
C
C     np is the degree of polynomial used in the akima spline interpolation
C
      np=3
C
C     rfit= point at which the exchange form is fit to the data and at
C     which is calculated the shift in the data required to match the
C     short and long range parts 
C     rjoin= point at which the short range data is smoothly connected
C     to the long range form
C     rfinal= last point for short range data set used in the calculations
C
      DATA rfit /15.5D0/, rjoin /17.D0/,rfinal /20.0d0/
C
C --- Long range: 
C     Yan, Babb, Dalgarno and Drake, Phys. Rev. A 54, 2824 (1996)
C     (in atomic units)
C
      DATA C6 /1393.39D0/, C8 /83425.8D0/, C10 /7372100.0D0/
C
C --- Long range exchange: 
C     Cote, Dalgarno, and Jamieson, Phys. Rev. A 50, 399 (1994)
C     (in atomic units)
C
      DATA  beta /1.25902D0/, gamma /4.55988D0/

C
C --- Short-range singlet potential data
C     ----------------------------------
C     De determined by Zemke and Stwalley, J. Phys. Chem. 97, 2053 (1993)
C     (in units of cm-1)   
C
      DATA Des /8516.61D0/
C
C     Section with E>0 : small R
C     1st 2 pts from Konowalow and Olson J. Chem. Phys. 71, 450 (1979)
C     3rd pt from Schmidt-Mink et al Chem. Phys. 92, 263 (1985)
C     (in atomic units)
C
      DATA rs1 / 2.75, 3.00, 3.25 /
C
      DATA vs1 / 0.061866D0, 0.036411D0, 0.013546D0 /
C
C     Section with E<0 : RKR potential
C     from Barakat et al Chem. Phys. 102, 215 (1986)  
C     note: misprints in data corrected, see Cote et al 
C           Phys. Rev A 50 399 (1994)
C     (in units of angstroms and cm-1)
C
      DATA res / 2.673247D0 /
C
      DATA rs2 / 1.823201D0, 1.823462D0, 1.824057D0,
     &           1.825118D0, 1.826727D0, 1.828918D0,
     &           1.831708D0, 1.834867D0, 1.838851D0,
     &           1.843462D0, 1.848639D0, 1.854376D0,
     &           1.860716D0, 1.867431D0, 1.874904D0,
     &           1.882864D0, 1.891368D0, 1.900497D0,
     &           1.910173D0, 1.920282D0, 1.931173D0,
     &           1.942717D0, 1.954984D0, 1.967947D0,
     &           1.981710D0, 1.996354D0, 2.011906D0,
     &           2.028431D0, 2.046073D0, 2.064963D0,
     &           2.085263D0, 2.107177D0, 2.130967D0,
     &           2.156977D0, 2.185675D0, 2.217724D0,
     &           2.254114D0, 2.296439D0, 2.347580D0,
     &           2.413867D0, 2.517207D0, 2.673247D0 /
C
      DATA vs2 / 8514.7777D0, 8507.8421D0, 8492.0440D0,
     &           8463.9645D0, 8421.6125D0, 8364.3068D0,
     &           8292.0294D0, 8205.2323D0, 8104.4730D0,
     &           7990.4162D0, 7863.7083D0, 7724.9765D0,
     &           7574.8736D0, 7413.8431D0, 7242.5556D0,
     &           7061.4199D0, 6870.8931D0, 6671.3979D0,
     &           6463.3140D0, 6246.9482D0, 6022.6578D0,
     &           5790.7056D0, 5551.3992D0, 5304.9322D0,
     &           5051.5343D0, 4791.4274D0, 4524.7756D0,
     &           4251.7309D0, 3972.4624D0, 3687.1094D0,
     &           3395.7978D0, 3090.6412D0, 2795.7419D0,
     &           2487.1914D0, 2173.0721D0, 1853.4573D0,
     &           1528.4128D0, 1197.9974D0,  862.2642D0,
     &            521.2611D0,  175.0320D0,    0.0000D0  /
C
      DATA rs3 / 12.639382D0, 9.863785D0, 8.495553D0,
     &           7.657218D0, 7.090991D0, 6.675227D0,
     &           6.352341D0, 6.089904D0, 5.870023D0,
     &           5.680896D0, 5.514781D0, 5.366746D0,
CX   &           5.580896D0, 5.514781D0, 5.366746D0,
     &           5.232506D0, 5.109851D0, 4.996566D0,
     &           4.890860D0, 4.791595D0, 4.697788D0,
CX   &           4.490860D0, 4.791595D0, 4.697788D0,
     &           4.608426D0, 4.522846D0, 4.440679D0,
     &           4.361370D0, 4.284400D0, 4.209387D0,
     &           4.135091D0, 4.064160D0, 3.993263D0,
     &           3.923163D0, 3.853594D0, 3.784295D0,
     &           3.714965D0, 3.645290D0, 3.574908D0,
     &           3.503385D0, 3.430172D0, 3.354534D0,
     &           3.275416D0, 3.191166D0, 3.098852D0,
     &           2.992096D0, 2.848951D0 /
C
      DATA vs3 / 8514.7777D0, 8507.8421D0, 8492.0440D0,
     &           8463.9645D0, 8421.6125D0, 8364.3068D0,
     &           8292.0294D0, 8205.2323D0, 8104.4730D0,
     &           7990.4162D0, 7863.7083D0, 7724.9765D0,
     &           7574.8736D0, 7413.8431D0, 7242.5556D0,
     &           7061.4199D0, 6870.8931D0, 6671.3979D0,
     &           6463.3140D0, 6246.9482D0, 6022.6578D0,
     &           5790.7056D0, 5551.3992D0, 5304.9322D0,
     &           5051.5343D0, 4791.4274D0, 4524.7756D0,
     &           4251.7309D0, 3972.4624D0, 3687.1094D0,
     &           3395.7978D0, 3090.6412D0, 2795.7419D0,
     &           2487.1914D0, 2173.0721D0, 1853.4573D0,
     &           1528.4128D0, 1197.9974D0,  862.2642D0,
     &            521.2611D0,  175.0320D0 /
C
C --- Short-range triplet potential data
C     ----------------------------------
C     De determined by Linton et al, J. Mol. Spect. 196, 20 (1999)
C     (in units of cm-1)
C
      DATA Det /333.70D0/
C
C     Section with E>0 : small R
C     1st pt from Konowalow and Olson J. Chem. Phys. 81, 4534 (1984)
C     7 pts from Schmidt-Mink et al Chem. Phys. 92, 263 (1985)
C     (in atomic units)
C
c      DATA rt1 / 3.00D0 , 3.25D0,  3.50D0,
c     &           4.00D0 , 4.50D0,  5.00D0,
c     &           5.50D0 , 6.00D0/
C
c      DATA vt1 / 0.104471D0, 0.082074D0, 0.063725D0,
c     &           0.036778D0, 0.020006D0, 0.010053D0,
c     &           0.004370D0, 0.001258D0 /  
C     
C    11 pts from Halls et al, Chem. Phys. Lett.  339, 427 (2001)        
C          distances in angstroms
c
      DATA rt1 / 2.00d0, 2.125d0, 2.25D0,  2.375D0,
     &           2.50d0, 2.625d0, 2.75d0,
     &           2.875d0, 3.00d0,  3.125d0, 3.25d0/

     
      DATA vt1 / 0.0472751972d0,
     &       0.0361788060d0, 0.0273239836d0, 0.0203412490d0,
     &       0.0148869076d0, 0.0106605276d0, 0.0074111640d0,
     &       0.0049337380d0, 0.0030628654d0, 0.0016656470d0,
     &       0.0006356372d0 /
C
C     Section with E<0 : RKR potential
C     from Linton et al J. Mol. Spect. 196, 20 (1999)  
C     (in units of angstroms and cm-1)
C
      DATA ret / 4.173D0 /
C
CFC      DATA rt2 / 3.356D0, 3.358D0, 3.365D0,
CFC     &           3.377D0, 3.395D0, 3.422D0,
CFC     &           3.458D0, 3.505D0, 3.571D0,
CFC     &           3.668D0, 3.846D0, 4.159D0,4.173D0 /
C
CFC      DATA vt2 / 333.269D0, 330.170D0, 322.155D0,
CFC     &           308.098D0, 287.665D0, 260.837D0,
CFC     &           227.679D0, 188.240D0, 142.523D0,
CFC     &           90.453D0,  31.857D0, 0.024D0,  0.000D0 /
C
CFC      DATA rt3 / 16.052D0, 11.392D0, 9.441D0,
CFC     &            8.297D0,  7.501D0,  6.885D0,
CFC     &            6.373D0,  5.922D0,  5.503D0,
CFC     &            5.092D0,  4.630D0 , 4.185D0/
C
CFC      DATA vt3 / 333.269D0, 330.170D0, 322.155D0,
CFC     &           308.098D0, 287.665D0, 260.837D0,
CFC     &           227.679D0, 188.240D0, 142.523D0,
CFC     &            90.453D0,  31.857D0,   0.024D0 /
C
C=============Initial setup=============================================
C
      IF(LSETUP) THEN 
          if (do_setup) then
          shift1=0.0d0
          shift3=0.13d-5
          c6=1393.39d0
CFC
!
!   Read new RKR points
!   
          open(unit=1200,file='./Potentials/ALLNEW/rkr.dat',
     +status='old')
          do i=1,nt2
              read(1200,*) rt2(i),vt2(i)
              !write(*,*) i,rt2(i),vt2(i)
          end do
          do i=1,nt3
              read(1200,*) rt3(i),vt3(i)
              !write(*,*) i,rt3(i),vt3(i)              
          end do
          close(1200)
          nt2off = 4   ! skip the first nt2off values of rkr data
       
C
C --- Calculate total number of potential data points
C
          ns=ns1+ns2+ns3 
          nt=nt1+nt2+nt3-nt2off
          if (ns.gt.nmax.or.nt.gt.nmax) then
              write(*,1000) ns,nt,nmax
          endif
C
C --- Order each set of data, in ascending order, into an array    
C     and smooth data by multiplying by R^6 for interpolation.
C     Convert data to atomic units.
C
          re1=res/bohra 
          re3=ret/bohra 
C
          do i=1,ns1      
              rdatas(i)=rs1(i) 
              vdatas(i)=vs1(i)
              vdatas(i)=vdatas(i)*rdatas(i)**6
          enddo
          do i=1,ns2
              j=ns1+i
              rdatas(j)=rs2(i)/bohra 
              vdatas(j)=(vs2(i)-des)/hartree
              vdatas(j)=vdatas(j)*rdatas(j)**6
          enddo
          do i=1,ns3
              j=ns1+ns2+i
              rdatas(j)=rs3(i)/bohra 
              vdatas(j)=(vs3(i)-des)/hartree
              vdatas(j)=vdatas(j)*rdatas(j)**6
          enddo
C   
          order=.true.     
          do i=2,ns
              if (rdatas(i).eq.rdatas(i-1)) then
                  write(*,1010) i-1,i
                  stop
              elseif (rdatas(i).lt.rdatas(i-1)) then
                  order=.false.
              endif
          enddo
          if (.not. order) then
              call sort (rdatas,vdatas,ns)
          endif
C
c          do i=1,nt0
c              rdatat(i)=rt0(i)/bohra 
c              vdatat(i)=vt0(i)
c              vdatat(i)=vdatat(i)*rdatat(i)**6
c          enddo
       
          do i=1,nt1
              j=i
              rdatat(j)=rt1(i)/bohra 
              vdatat(j)=vt1(i)
              vdatat(j)=vdatat(j)*rdatat(j)**6
          enddo
C
C         Note: 1st and 2nd points of the RKR data had to be omitted  
C               to prevent oscillations in the spline fit between
C               the two sets of data 
CFC
CFC      Now we omit the first nt2off points of the left side
CFC      of RKR data.
CFC
          do i=nt2off+1,nt2
              j=nt1-nt2off+i
              rdatat(j)=rt2(i)/bohra 
              vdatat(j)=(vt2(i)-det)/hartree
              vdatat(j)=vdatat(j)*rdatat(j)**6
          enddo
          do i=1,nt3
              j=nt1+nt2-nt2off+i
              rdatat(j)=rt3(i)/bohra 
              vdatat(j)=(vt3(i)-det)/hartree
              vdatat(j)=vdatat(j)*rdatat(j)**6
          enddo
C
          order=.false.     
          do i=2,nt
              if (rdatat(i).eq.rdatat(i-1)) then
                  write(*,*) 'Error in RKR data'
                  write(*,1010) i-1,i
                  write(*,'(2f20.8)') rdatat(i-1),vdatat(i-1)
                  write(*,'(2f20.8)') rdatat(i),vdatat(i)                  
                  stop
              elseif (rdatat(i).lt.rdatat(i-1)) then
                  order=.false.
              endif
          enddo
          if (.not. order) then
              call sort (rdatat,vdatat,nt)
          endif
C
          if (output_data) then
              do i=1,ns 
                  write(50,1100) rdatas(i),vdatas(i)/rdatas(i)**6
              enddo  
              do i=1,nt 
                  write(51,1100) rdatat(i),vdatat(i)/rdatat(i)**6
              enddo  
C
              do i=1,ns
                  rdat(i)=rdatas(i)
                  vdats(i)=vdatas(i)
                  do j=1,nt
                      if (rdatas(i).eq.rdatat(j)) then
                          vdatt(i)=vdatat(j)
                      else
                          call akima(np,nt,rdatat,vdatat,1,rdat(i),vt)
                          vdatt(i)=vt
                      endif
                  enddo
              enddo
C
              k=ns
              do i=1,nt
                  norepeat=.true.
                  do j=1,ns                
                      if (rdatat(i).eq.rdatas(j)) then
                          norepeat=.false.
                      endif
                  enddo
                  if (norepeat) then  
                      k=k+1 
                      rdat(k)=rdatat(i)
                      vdatt(k)=vdatat(i)
                      call akima(np,ns,rdatas,vdatas,1,rdat(k),vs)
                      vdats(k)=vs
                  endif
              enddo
              ndat=k
              call sort2 (rdat,vdats,vdatt,ndat)
C
              do i=1,ndat
                  write(52,1110) rdat(i),vdats(i),vdatt(i)
              enddo
C
          endif 
C 
C --- Fit Smirnov and Chibisov exchange form: A exp(-beta R) R^gamma 
C     to the exchange energy determined from the potential data to
C     obtain the amplitude A
C     
C     Calculate A at the chosen fitting point 
C
C      Interpolate potential data using akima spline interpolation
C      
          call akima(np,ns,rdatas,vdatas,1,rfit,vs)
          call akima(np,nt,rdatat,vdatat,1,rfit,vt)
C
C      Determine fitting constant A
C
          vt=vt/rfit**6
          vs=vs/rfit**6 
          vex=log((vt-vs)/2.0d0)
          CA=vex+beta*rfit-gamma*log(rfit)
          CA=exp(CA)
          write(*,*) CA
C
C --- Calculate the average of vs and vt, which should correspond 
C     with vdisp 
C
          vav=(vt+vs)/2.0d0
          vdisp=-c6/rfit**6-c8/rfit**8-c10/rfit**10
          vshift=vdisp-vav
          write(*,*) vshift
          write(*,*) vdisp
          write(*,*) exp(vex)
C
C --- Shift short range data by calculated difference to match the 
C     long range form
C
         ! vshift = 0d0
          nsl=0
          do i=1,ns
          !    vdatas(i)=vdatas(i)+vshift*rdatas(i)**6
              if(nsl.eq.0.and.rdatas(i).ge.rfit) nsl=i
          enddo
          ntl=0
          do i=1,nt
          !    vdatat(i)=vdatat(i)+vshift*rdatat(i)**6
              if(ntl.eq.0.and.rdatat(i).ge.rfit) ntl=i
          enddo
          if(nsl.eq.0.or.ntl.eq.0) then
              write(*,1020) rfit
              stop
          endif
C
C --- Connect short range data onto long range form using akima spline
C     to smooth across the connection 
C
!          call akima(np,ns,rdatas,vdatas,1,rfit,vs)
!          call akima(np,nt,rdatat,vdatat,1,rfit,vt)
          rdatas(nsl)=rfit      
          rdatat(ntl)=rfit
          vdatas(nsl)=(-(vt-vs)/2.0d0+vdisp)*rfit**6
          vdatat(ntl)=( (vt-vs)/2.0d0+vdisp)*rfit**6
          write(*,*) 'ntl =',ntl
          write(*,*) 'nt  =',nt          
!          vdatas(nsl)=vs
!          vdatat(ntl)=vt
C
          delta = 0.5d0
          ni=int((rfinal-rjoin)/delta)+1
!          ni = 2
          ndatas=nsl+ni
          ndatat=ntl+ni  
          ri=rjoin
          do i=1,ni             
              vex=CA*exp(-beta*ri)*ri**gamma
              vdisp=-c6/ri**6-c8/ri**8-c10/ri**10
C
              rdatas(nsl+i)=ri       
              rdatat(ntl+i)=ri
              vdatas(nsl+i)=(vdisp-vex)*ri**6       
              vdatat(ntl+i)=(vdisp+vex)*ri**6
C
              ri=ri+delta
          enddo
          rfinal=rdatas(ndatas)
C
C     Extrapolate short range data using the form: aexp(-br)
C  
          r1=rdatas(1)
          r2=rdatas(1)+1d-6
          call akima(np,ndatas,rdatas,vdatas,1,r1,v1)
          call akima(np,ndatas,rdatas,vdatas,1,r2,v2)
          if (v1*v2.lt.0.0d0) then
              write(*,1030) 
              stop
          endif
          v1=v1/r1**6
          v2=v2/r2**6 
          bs=log(v1/v2)/(r2-r1)
          as=v2*exp(bs*r2) 
C
          r1=rdatat(1)
          r2=rdatat(1)+1d-6
          !call akima(np,ndatat,rdatat,vdatat,1,r1,v1)
          call akima(np,ndatat,rdatat,vdatat,1,r2,v2)
          if (v1*v2.lt.0.0d0) then
              write(*,1030) 
              stop
          endif
          v1=vdatat(1)/r1**6
          v2=v2/r2**6
          bt=log(v1/v2)/(r2-r1)
          at=v2*exp(bt*r2) 
C
C     Output potential details/parameters
C
          write(*,1040) c6,c8,c10
          write(*,1050) rfit,CA,beta,gamma
          write(*,1060) vshift,vshift*hartree
          write(*,1070) rjoin,rfinal
          write(*,1080) as,bs,at,bt

      endif
C
      do_setup=.not.do_setup
      SYS_SS_pot_3=0.0d0
C
      RETURN 
      ENDIF    
C
C=======================================================================
C
      IF((NV.LE.0).OR.(NV.GT.2)) THEN
          WRITE(*,900)
          STOP
      END IF
C
      GO TO (10,20),NV
C
C=======================================================================
C
C --- SECTION FOR NV=1 -- Calculate singlet potential
C
   10 call mpot(np,ndatas,rdatas,vdatas,c6,c8,c10,
     >          CA,beta,gamma,as,bs,nv,r,v)
C
      v=v+correction_ss(r,shift1,re1)
      SYS_SS_pot_3=V
C
      RETURN
C
C=======================================================================
C
C --- SECTION FOR NV=2 -- Calculate triplet potential
C
   20 call mpot(np,ndatat,rdatat,vdatat,c6,c8,c10,
     >          CA,beta,gamma,at,bt,nv,r,v)
C
      v=v+correction_ss(r,shift3,re3)
      SYS_SS_pot_3=V
C
      RETURN
C
C=======================================================================
C
C --- FORMAT STATEMENTS ------------------------------------------------
C
  900 FORMAT(//,' Program HALTED in Potential Subroutine -- NV OUT ',
     X  'OF RANGE')
C
  990 FORMAT(//,'MOLECULAR POTENTIAL DATA')
 1000 format(//,'ERROR in Potential Subroutine -- no. of data points',
     X  'exceeds array size:',3i6)
 1010 format(//,'ERROR in Potential Subroutine -- identical data for',
     X  'pair:',2i6)
 1020 format(//,'ERROR in Potential Subroutine -- rfit (au)=',d14.6,
     X  'exceeds short range data')
 1030 format(//,'ERROR in Potential Subroutine -- data points used in',
     X  'short range extrapolation of data cross a zero')
 1040 format(//,'Long range dispersion coefficients (au):',/,
     X  ' C6=',d14.6,' C8=',d14.6,' C10=',d14.6)
 1050 format(//,'Long range exchange, Aexp(-beta R)R^gamma (au):',/,
     X  ' fit to short range data at R=',d14.6,/,
     X  ' A=',d14.6,' beta=',d14.6,' gamma=',d14.6)
 1060 format(/,'Shift applied to short range data to match to',
     X  ' long range form:',/,
     X  d14.6,' au',' or',d14.6,' cm-1')
 1070 format(//,'Long range form assumed at R (au)=',d14.6,/,
     X  'Short range data extended to R (au)=',d14.6)
 1080 format(//,'Short range extrapolation, aexp(-bR) (au)',/,
     X  'Singlet: a=',d14.6,' b=',d14.6,/,
     X  'Triplet: a=',d14.6,' b=',d14.6)
 1100 format(2d16.8)
 1110 format(3d16.8)
 1120 format(4d16.8)
C
      END
      !-------------------------------------------------------------------
      ! function  : vli2
      !
      ! package   : Li3 Potential
      !
      ! Language  : Fortran 77
      !
      ! author    : F. Colavecchia (flavioc@lanl.gov)
      !
      ! date      : 05/12/02
      ! revision  :
      !
      ! purpose   : wrapper for the sys_ss_pot_3 routine
      !
      ! input     :    r    -> interatomic distance in bohr.
      !
      ! output    :    vli2 -> li2 potential in a.u.  
      !
      !-------------------------------------------------------------------
      real*8 function vli2(r)
      implicit none
      real*8 r,v,sys_ss_pot_3
      integer nv
      logical lsetup
      data lsetup /.true./
      save lsetup           
      
      nv = 2   ! Triplet potential
      !nv = 1   ! Singlet potential
      v = 0d0 
      if(lsetup) then 
           vli2 = sys_ss_pot_3(r,v,nv,lsetup)
           lsetup = .false.
      end if
      vli2 = sys_ss_pot_3(r,v,nv,lsetup)

      if(r.eq.0.d0)vli2= 3.062396111034812d0

      return
      end  

*dk surface
      subroutine surface_2APP(v,rij)
c this potential is for 1A' in Li3 potential
c for 2475 points in c2v, RMS=2.76d-4 Ha.
c for 55 other points in Cs, RMS=8.7d-4 Ha.
c written by X.L. li@nhn.ou.edu
c-----------------------------------------------------------------------
c This routine supplies the potential energy surface for the
c reactive scattering codes.
c
c On entering: The array rij contains the internuclear distances
c              in units of bohr (NOT mass scaled).
c
c              The common /pes/ must contain a character string
c              of length 20 that properly describes the potential.
c
c On Exit:     The variable v is the value of the potential energy
c              surface in Hartree atomic units.
c
c
c-----------------------------------------------------------------------
      implicit NONE
      REAL*8 rij(3),EHAMIL(37),v3b,v,x(3),vli2
c-----------------------------------------------------------------------
c This call to surfac supplies the potential energy surface
c for the particular system of interest.
c-----------------------------------------------------------------------
          
           x(1)=maxval(rij)
           x(3)=minval(rij)
           x(2)=max(min(rij(1),rij(2)),
     & min(rij(2),rij(3)),min(rij(1),rij(3)))

          call Vhamil_APP(Ehamil,x)
c          call TRI3B_2APP_NCNW(x(1),x(2),x(3),v3b)
c          IF(maxval(rij).lt.4d0.and.EHAMIL(1).gt.0.15d0)v3b=0d0
c          v=v3b+Ehamil(2)
          v=Ehamil(2)
      return
      end

MODULE FileUnits_Module
   IMPLICIT NONE
   SAVE
   INTEGER, PARAMETER::msg_Unit      =  6
   INTEGER, PARAMETER::In_Unit       =  3
   INTEGER, PARAMETER::Out_Unit      =  4
   INTEGER, PARAMETER::frst_Unit     = 14
   INTEGER, PARAMETER::pmat_Unit     = 15
   INTEGER, PARAMETER::ovr_Unit      = 16
   INTEGER, PARAMETER::elvl_Unit     = 17
   INTEGER, PARAMETER::work_Unit     = 18
   INTEGER, PARAMETER::dwork_Unit    = 19
   INTEGER, PARAMETER::todo_Unit     = 20
   INTEGER, PARAMETER::phmat_Unit    = 21
   INTEGER, PARAMETER::fph_Unit      = 22
   INTEGER, PARAMETER::dmu_Unit      = 23
   INTEGER, PARAMETER::low_Unit      = 24
   INTEGER, PARAMETER::e_Unit        = 25
   INTEGER, PARAMETER::p_Unit        = 26
   INTEGER, PARAMETER::q_Unit        = 27
   INTEGER, PARAMETER::norm_Unit     = 28
   INTEGER, PARAMETER::intrp_Unit    = 29
   INTEGER, PARAMETER::bas_Unit      = 30
   INTEGER, PARAMETER::res_Unit      = 31
   INTEGER, PARAMETER::inho_Unit     = 32
   INTEGER, PARAMETER::tmutp_Unit    = 33
   INTEGER, PARAMETER::sflvl_Unit    = 34
   INTEGER, PARAMETER::jtot_Unit     = 35
   INTEGER, PARAMETER::lam_Unit      = 36
   INTEGER, PARAMETER::asym_Unit     = 37
   INTEGER, PARAMETER::cor_Unit      = 38
   INTEGER, PARAMETER::sbfrst_Unit   = 39
   INTEGER, PARAMETER::vec_Unit      = 40
   INTEGER, PARAMETER::vfrst_Unit    = 41
   INTEGER, PARAMETER::pfrst_Unit    = 42
   INTEGER, PARAMETER::weight_Unit   = 43
   INTEGER, PARAMETER::wfrst_Unit    = 44
   INTEGER, PARAMETER::sf33_Unit     = 45
   INTEGER, PARAMETER::sf34_Unit     = 46
   INTEGER, PARAMETER::phip_Unit     = 47
   INTEGER, PARAMETER::phid_Unit     = 48
   INTEGER, PARAMETER::efun_Unit     = 49
   INTEGER, PARAMETER::elm_Unit      = 50
   INTEGER, PARAMETER::nmode_Unit    = 51
   INTEGER, PARAMETER::progre_Unit   = 52
   INTEGER, PARAMETER::umat_Unit     = 53
   INTEGER, PARAMETER::sfunfbr_Unit  = 54
   INTEGER, PARAMETER::sflvl_Unit2   = 61
   INTEGER, PARAMETER::dvr7          = 67
   INTEGER, PARAMETER::dvr11         = 71
   INTEGER, PARAMETER::dvr12         = 72
   INTEGER, PARAMETER::dvr13         = 73
   INTEGER, PARAMETER::dvr14         = 74
   INTEGER, PARAMETER::dvr15         = 75
   INTEGER, PARAMETER::dvr16         = 76
   INTEGER, PARAMETER::dvr18         = 91
   INTEGER, PARAMETER::dvr23         = 77
   INTEGER, PARAMETER::dvr22         = 81
   INTEGER, PARAMETER::csv_unit      = 82
   INTEGER, PARAMETER::Vee_Unit      = 83
   INTEGER, PARAMETER::MTV_Unit      = 84
END MODULE FileUnits_Module
MODULE Numeric_Kinds_Module
   IMPLICIT NONE
   SAVE
   INTEGER, PARAMETER  :: sp=KIND(1.0)                   ! Single precsion
   INTEGER, PARAMETER  :: dp=SELECTED_REAL_KIND(14,300)  ! Double precsion
END MODULE Numeric_Kinds_Module

      !-------------------------------------------------------------------
      ! subroutine: vli3
      !
      ! package   : Li3 Potential
      !
      ! Language  : Fortran 77
      !
      ! author    : F. Colavecchia (flavioc@lanl.gov)
      !
      ! date      : 05/12/02
      ! revision  :
      !
      ! purpose   : Li3 potential
      !
      ! input     :    r    -> (dim=3) interatomic distances in bohr.
      !
      ! output    :    v -> Li3  potential in a.u.
      !
      !-------------------------------------------------------------------!
      subroutine vli3_F(r,v)
      implicit none
      real*8 r(3),v,vli2,vli3_at
!
!     Compute the two body part
!     All this is in a.u.
!
      v = 0d0
      v = vli2(r(1))+vli2(r(2))+vli2(r(3))
      v = v + vli3_at(r)
      return 
      end 

SUBROUTINE ErrWrt (ErrMsg)
USE FileUnits_Module
!
!-------------------------------- ErrWrt -------------------------------
!
! >>> ErrWrt   -- writes a message to the standard error output file
!
! *** Calling Sequence:   CALL ErrWrt ( ErrMsg )
!
! === Latest Revision:    25 May 1988  (typed in)
!
! --- on entry the calling routine supplies --
!
!     ErrMsg   -- character string to be written to standard error
!
! --- on exit the routine returns --
!
!     nothing
!
!----------------------------- local declarations ----------------------
!
!
CHARACTER (len=*) ::    ErrMsg
!
! * * * * *                !  INTEGER globals
CHARACTER (len=8  ) :: IGlobal
! * * * * *              !    output line
CHARACTER (len=80    ) :: Line
! * * * * *               !   output FORMAT
CHARACTER (len=8  ) :: MyForm
!
! * * * * *            !   standard error unit number
INTEGER ::        StdErr
! * * * * *            !   right index function
INTEGER ::        IndexR
! * * * * *           !    # characters to output
INTEGER ::        NCOut
!
!---------------------------- execution begins here --------------------
!
IF(IGlobal ('get', 'StdErr', StdErr) .ne.'OK') RETURN
!
Line   = ErrMsg
NCOut     = max (1, IndexR (Line) )
!
MyForm    = '(a!!)'
WRITE (MyForm (3:4) , '(i2)') NCOut
!
WRITE (StdErr, MyForm) Line (1:NCOut)
!
RETURN
END SUBROUTINE ErrWrt
SUBROUTINE FndInt (n, array, value, start, FindLoc)
USE Numeric_Kinds_Module
USE FileUnits_Module
!
! >>> FndInt -- finds the interval where value lies in the array
!
! --- on entry the calling routine supplies --
!
!     n     -- the number of elements in the array
!     array -- a monotonically nondecreasing array of floating point
!                numbers (i.e., increasing array )
!     value -- test value to find in the array
!     start -- integer initial guess where value is in the array
!
! --- on exit the routine returns --
!
!     FindLoc  -- integer value locating where value is in the array, so
!                that array(FindLoc) .le. value .lt. array(FindLoc+1), and
!                if value .lt. array(1), then FindLoc = 0, and
!                if value .ge. array(n), then FindLoc = n
!
! --- Method:  routine first checks to see if the test value is outside
!                the array bounds (FindLoc=0 or n), then checks
!                the current interval and adjacent intervals,
!                where FindLoc=start, start-1, or start+1.  If correct
!                interval is not located by this point, routine
!                branches into a binary search.  Because of the
!                interval end conditions, it takes
!                   1 test to locate FindLoc=0
!                   2 tests to locate FindLoc=n
!                   4 tests to locate FindLoc=start, or start-1, and
!                   5 tests to locate FindLoc=start+1
INTEGER :: high, low, FindLoc, start, Look, N
REAL*8 :: array (n), value
!
high = n
low = 1
!
!     CHECK SPECIAL CASES
!
!     -- check out of bounds conditions
!
!      ntests = 1
IF(value.lt.array (1) ) THEN
   FindLoc = 0
   RETURN
ELSEIF (value.ge.array (n) ) THEN
   FindLoc = n
!         ntests = 2
   RETURN
ENDIF
!
!    -- check intervals next to the start search
!
look = min0 (n, max0 (1, start) )
!      ntests = 4
IF(value.lt.array (look) ) THEN
   high = look
   IF(value.lt.array (high - 1) ) THEN
      high = high - 1
   ELSE
      FindLoc = high - 1
      RETURN
   ENDIF
ELSE
   low = look
   IF(value.lt.array (low + 1) ) THEN
      FindLoc = low
      RETURN
   ELSE
      low = low + 1
!            ntests = 5
      IF(value.lt.array (low + 1) ) THEN
         FindLoc = low
         RETURN
      ELSE
         low = low + 1
      ENDIF
   ENDIF
ENDIF
!
!     NOT A SIMPLE ANSWER, BEGIN BINARY SEARCH
!
look = (high + low) / 2
look = min0 (high - 1, look)
look = max0 (low + 1, look)
    1 CONTINUE
IF(high - low.eq.1) THEN
   FindLoc = low
   RETURN
ELSE
!         ntests = ntests + 1
   IF(value.lt.array (look) ) THEN
      high = look
   ELSE
      low = look
   ENDIF
!
   look = (high + low) / 2
   look = min0 (high - 1, look)
   look = max0 (low + 1, look)
ENDIF
goto 1
END SUBROUTINE FndInt
FUNCTION IGlobal (Command, Name, Value)
!
!-----------------------------------------------------------------------
!
! >>> IGlobal   -- integer global variable saver routine
!
! *** Calling Sequence:         Result  = IGlobal(Command,Name,Value)
!
! --- on entry the calling routine supplies --
!
!     Command   -- character string indicating whether the indicated glo
!                       variable is to be saved, retrieved, or deleted
!                       Possible Commands are:
!                               Command = 'save'        to save a global
!                               Command = 'get'         to retrieve one
!                               Command = 'delete'      to remove one
!                               Command = 'list'        to write EVERYTH
!               NOTE:  only the first character of Command is significan
!
!     Name      -- character string (8 or fewer characters) indicating t
!                       unique name of the global to be saved/retrieved/
!
!     Value     -- integer which is an input variable if Command='save'
!                       If Command .ne. 'save', Value is not read on inp
!
! --- on exit the routine returns --
!
!     Value     -- is an output integer variable only if Command='get',
!                       which case the remembered value of the Name-d
!                       global variable is returned.
!
!     IGlobal   -- is a character string indicating the success/failure
!                       the operation.  Possible returns are:
!                               IGlobal = 'OK'    if all was OK
!                               IGlobal = 'CANT'  if no internal space l
!                                               a 'save' operation, or i
!                                               Named variable is not he
!                                               a 'delete' or 'get'.
!                               IGlobal = 'WHAT'  if Command unrecognize
!
!-----------------------------------------------------------------------
!
!
CHARACTER (len=4) :: IGlobal
CHARACTER (len=*) :: Command
CHARACTER (len=*) :: Name
INTEGER :: Value
!
INTEGER :: MAXSave
PARAMETER (MAXSave = 100)
!
INTEGER :: NSaved
! * * * * *                             !       loop index
INTEGER :: i
! * * * * *                             !       new value of NSaved
INTEGER :: new
! * * * * *                             !       value of output unit if
INTEGER :: iout
!
INTEGER :: Save (MAXSave)
CHARACTER (len=8) :: VNames (MAXSave)
!
save
!
DATA NSaved / 5 /
!
DATA VNames (1) / 'StdIn' /
DATA Save (1) / 9 /
!
DATA VNames (2) / 'StdOut' /
DATA Save (2) / 9 /
!
DATA VNames (3) / 'StdErr' /
DATA Save (3) / 9 /
!
DATA VNames (4) / 'StdDbg' /
DATA Save (4) / 9 /
!
DATA VNames (5) / 'StdWrt' /
DATA Save (5) / 9 /
!
!
!---------------------------- execution begins here --------------------
!
!
!                        --- blank Names NOT allowed ---
!
IF(Name.eq.' ') THEN
   IGlobal = 'CANT'
   RETURN
ENDIF
!
!                    --- special case if Command = 'list' ---
!
IF(Command (1:1) .eq.'l') THEN
   DO 100 i = 1, NSaved
      IF(Name.eq.VNames (i) ) THEN
         iout = Save (i)
         goto 101
      ENDIF
  100    END DO
   iout = 0
   IGlobal = 'CANT'
  101    CONTINUE
   IF(iout.eq.0) RETURN
!
WRITE (iout,  * ) '   === INTEGER Globals ==='
   DO 200 i = 1, NSaved
      IF(VNames (i) .ne.' ') THEN
         WRITE (iout, '(5x,a8,'' = '',i10)') VNames (i) , Save (i)
      ENDIF
  200    END DO
   IGlobal = 'OK'
   RETURN
ENDIF
!
!                     --- has Name already been defined? ---
!
DO 1 i = 1, NSaved
   IF(Name.eq.VNames (i) ) goto 2
    1 END DO
i = 0
    2 CONTINUE
!
!---------------------------- saving a value ---------------------------
!
IF(Command (1:1) .eq.'s') THEN
!
   IF(i.eq.0) THEN
      new = NSaved+1
      IF(new.gt.MAXSave) THEN
!
!               --- arrays full, look for a blank entry ---
!
         DO 10 i = 1, NSaved
            IF(VNames (i) .eq.' ') goto 11
   10          END DO
         i = 0
   11          CONTINUE
         IF(i.eq.0) THEN
            IGlobal = 'CANT'
            RETURN
         ELSE
            new = NSaved
         ENDIF
      ENDIF
!
!                --- save value for the newly defined global ---
!
      NSaved = new
      VNames (NSaved) = Name
      Save (NSaved) = Value
      IGlobal = 'OK'
!
!           --- save a new value for a previously defined global ---
!
   ELSE
      Save (i) = Value
      IGlobal = 'OK'
   ENDIF
!
!----------------------------- retrieving a value ----------------------
!
ELSEIF (Command (1:1) .eq.'g') THEN
!
   IF(i.eq.0) THEN
      IGlobal = 'CANT'
   ELSE
      IGlobal = 'OK'
      Value = Save (i)
   ENDIF
!
!----------------------------- deleting a global -----------------------
!
ELSEIF (Command (1:1) .eq.'d') THEN
!
   IF(i.eq.0) THEN
      IGlobal = 'CANT'
   ELSE
      IGlobal = 'OK'
      VNames (i) = ' '
   ENDIF
!
!---------------------------- unrecognized command ---------------------
!
ELSE
   IGlobal = 'WHAT'
ENDIF
!
RETURN
END FUNCTION IGlobal
FUNCTION IndexR (String)
!
!-----------------------------------------------------------------------
!
! >>> IndexR -- returns the index of the last non-blank character, or a
! >>>             if the entire string is blank
!
! *** Calling Sequence:         IPos    = IndexR ( String )
!
!-----------------------------------------------------------------------
!
!
INTEGER :: IndexR
CHARACTER (len=*) :: String
!
! * * * * *                             !       loop index
INTEGER :: i
!
!----------------------- execution begins here -------------------------
!
DO 1 i = len (String), 1, - 1
   IF(String (i:i) .ne.' ') THEN
      IndexR = i
      RETURN
   ENDIF
    1 END DO
!
IndexR = 0
!
RETURN
END FUNCTION IndexR
SUBROUTINE SPL1D1 (N, X, F, W, IOP, IJ, A, B, C)
USE Numeric_Kinds_Module
SAVE
!***BEGIN PROLOGUE  SPL1D1
!***DATE WRITTEN   790301   (YYMMDD)
!***REVISION DATE  831207   (YYMMDD)
!***CATEGORY NO.  E1A
!***KEYWORDS  SPLINES,CUBIC SPLINES,COEFFICIENTS
!***AUTHOR  JORDAN, TOM, LOS ALAMOS NATIONAL LABORATORY
!***PURPOSE  Finds coefficients of cubic for spline interpolation.
!***DESCRIPTION
!
!     SPL1D1 computes the coefficients of a sequence of cubics for
!     spline interpolation.  This subroutine will normally be used in
!     conjunction with SPL1D2.
!
!     -ARGUMENTS-
!
!      N = integer specifying the number of points.
!      X = origin of the table of floating point values of independent
!          variable.  This table must be in ascending order.
!      F = origin of the table of floating point values of the dependent
!          variable.
!      W = origin of the table of floating point values of the second
!          derivatives of the spline at each knot.  The W's and F's
!          define the cubic over each interval.
!    IOP = an array of dimension 2 containing combinations of the
!          integers 1 through 5 for specifying the boundary conditions
!          (see Boundary Conditions).
!     IJ = integer specifying spacing in tables F and W.  Normally,
!          IJ = 1.
!  A,B,C = arrays of dimension N used for temporary storage.  These
!          arrays may be used by the calling program at any other
!          time.
!
!     The second derivatives are computed and stored in W, length N.
!
!     ERROR CONDITIONS:
!
!        If option 5 is specified with N < 4, this routine uses XERROR
!     to print the following error message:  "SPL1D1 N LESS THAN 4.
!     RESULTS INCORRECT."
!
!     BOUNDARY CONDITIONS:
!
!        IOP(1) and IOP(2) are integers = 1,2,3,4 or 5.  By proper
!     combinations of these parameters, the user has a variety of
!     allowable end conditions.  The information associated with the end
!     conditions must be stored in W(1) and W(K) where K = (N-1)*IJ+1.
!
!        If IOP(1) = 1, then W(1) is the value of the second derivative
!     at X .  If IOP(1) = 2, then W(1) determines F''(X ) by the
!         1                                            1
!     relation F''(X ) = W(1) * F''(X ).  If IOP(1) = 3, then W(1) is
!                   1                2
!     the value of the first derivative at X .  IOP(1) = 4 allows
!                                           1
!     periodic boundary conditions, i.e., F'' = F'', F  = F .  If
!                                          1     N    1    N
!     IOP(1) = 5, the first derivative at X, is calculated by using a
!     differentiated four-point Lagrangian interpolation formula
!     evaluated at X .  For this case, W(1) need not be specified.
!                   1
!
!     The paragraph above describes the possibilities at the left
!     boundary.  The same holds at the right boundary, i.e., at X ,
!                                                                N
!     with the necessary boundary information stored at W(K). For
!     example, if IOP(2) = 2 then W(K) determines F''(X ) by the
!                                                      N
!     relation F''(X ) = W(K) * F''(X   ).
!                   N                N-1
!
!         Also, any combination of the above boundary conditions with
!     the exception of the periodic case may be used.  If the user
!     knows the second derivative at the left boundary and the first
!     derivative at the right boundary then IOP=(1) = 1, IOP(2) = 3,
!     W(1) = y'', W(K) = y'.  For LOGICAL results, the user must have
!             1           N
!     IOP(1) = 4 and IOP(2) = 4 for the periodic boundary conditions.
!
!     CAUTION:
!
!        In options 2 and 3, the input data in W(1) and W(K) is
!     destroyed by SPL1D1.  These boundary conditions must be reset if
!     SPL1D1 is to be used again.  For option 5, the user must have
!     N >= 4.
!
!
!     METHOD:
!
!        Given N knots a = X  < X  < X  ... X  = b on the interval
!                           1    2    3      N
!     [a,b] and prescribed function values at the knots, say
!     F(X ) = F , k = 1, 2, ..., N, cubics are joined between the points
!        k     k
!     (X ,F ) with the requirement that first and second derivatives
!       k  k
!     be continuous at these points.  This requirement yields N-2
!     equations in the N unknowns F'', F'', ..., F'' which when coupled
!                                  1    2         N
!     with two boundary conditions yields a system of equations solvable
!     for the quantities F''.  A complete discussion of the method may
!                         k
!     be found in the reference listed below.
!
!***REFERENCES  Walsh, Ahlberg, and Nilson, Journal of Mathematics and
!                 Mechanics, Vol. II, No. 2, 1962.
!***ROUTINES CALLED  XERROR
!***END PROLOGUE  SPL1D1
SAVE
INTEGER IOP(2), N, K, M, j1, j2, k2, k3, ij, i, k1, k4, j, l1, l2, l3, mk, ml
REAL*8 con, don, e, c1, c2, a1, a2, a3, a4, a5, a6
REAL*8 b1, b2, b3, b4, b5, b6, bob, bill, d1, d2
REAL*8 X (N), F (N), W (N), A (N), B (N), C (N)
!***FIRST EXECUTABLE STATEMENT  SPL1D1
K = N - 1
A (2) = - (X (2) - X (1) ) / 6.d0
B (2) = (X (3) - X (1) ) / 3.d0
W (IJ + 1) = (F (2 * IJ + 1) - F (IJ + 1) ) / (X (3) - X (2) ) - (F (IJ + 1) - F (1) ) / (X (2) - X (1) )
IF(N.eq.3)GOTO 4
   DO I = 3, K
      M = (I - 1) * IJ + 1
      J1 = M + IJ
      J2 = M - IJ
      CON = (X (I + 1) - X (I - 1) ) / 3.d0
      DON = (X (I) - X (I - 1) ) / 6.d0
      B (I) = CON - (DON**2) / B (I - 1)
      E = (F (J1) - F (M) ) / (X (I + 1) - X (I) ) - (F (M) - F (J2)) / (X (I) - X (I - 1) )
      W (M) = E- (DON * W (J2) ) / B (I - 1)
      A (I) = - (DON * A (I - 1) ) / B (I - 1)
   ENDDO
4  K1 = (N - 2) * IJ + 1
   C (N - 1) = - ( (X (N) - X (N - 1) ) / 6.d0) / B (N - 1)
   W (K1) = W (K1) / B (N - 1)
   A (N - 1) = A (N - 1) / B (N - 1)
   K2 = K - 1
IF(N.eq.3)GOTO 8
   DO I = 2, K2
      J = N - I
      CON = (X (J + 1) - X (J) ) / 6.d0
      A (J) = (A (J) - CON * A (J + 1) ) / B (J)
      C (J) = - (CON * C (J + 1) ) / B (J)
      K3 = (J - 1) * IJ + 1
      M = K3 + IJ
      W (K3) = (W (K3) - CON * W (M) ) / B (J)
   ENDDO
8  K4 = (N - 1) * IJ + 1
IF(IOP (1).eq.5)GOTO 200
  201 C1 = W (1)
IF(IOP (2).eq.5)GOTO 202
  203 C2 = W (K4)
GOTO 205
  200 IF(N.lt.4)GOTO 300
  302 A1 = X (1) - X (2)
A2 = X (1) - X (3)
A3 = X (1) - X (4)
A4 = X (2) - X (3)
A5 = X (2) - X (4)
A6 = X (3) - X (4)
W (1) = F (1) * (1.d0 / A1 + 1. / A2 + 1.d0 / A3) - A2 * A3 * F (IJ + &
 1) / (A1 * A4 * A5) + A1 * A3 * F (2 * IJ + 1) / (A2 * A4 * A6) &
 - A1 * A2 * F (3 * IJ + 1) / (A3 * A5 * A6)
GOTO 201
  202 IF(N.lt.4)GOTO 300
  303 B1 = X (N) - X (N - 3)
B2 = X (N) - X (N - 2)
B3 = X (N) - X (N - 1)
B4 = X (N - 1) - X (N - 3)
B5 = X (N - 1) - X (N - 2)
B6 = X (N - 2) - X (N - 3)
L1 = K4 - IJ
L2 = L1 - IJ
L3 = L2 - IJ
W (K4) = - B2 * B3 * F (L3) / (B6 * B4 * B1) + B1 * B3 * F (L2) &
 / (B6 * B5 * B2) - B1 * B2 * F (L1) / (B4 * B5 * B3) + F (K4) &
 * (1.d0 / B1 + 1.d0 / B2 + 1.d0 / B3)
GOTO 203
  205 CONTINUE
I = 0
   50 CONTINUE
I = I + 1
IF(I.gt.K) goto 100
!
M = (I - 1) * IJ + 1
GOTO 60
   70 IF(I.eq.1)GOTO 50
   80 W (1) = W (1) - BOB * W (M)
W (K4) = W (K4) - BILL * W (M)
A (1) = A (1) - BOB * A (I)
A (N) = A (N) - BILL * A (I)
C (1) = C (1) - BOB * C (I)
C (N) = C (N) - BILL * C (I)
goto 50
!
   60 MK = IOP (1)
IF(MK.eq.1)GOTO 62
IF(MK.eq.2)GOTO 64
IF(MK.eq.3)GOTO 66
IF(MK.eq.4)GOTO 68
IF(MK.eq.5)GOTO 66
   62 IF(I.ne.1)GOTO 71
   63 A (1) = - 1.d0
C (1) = 0.
GOTO 500
   71 BOB = 0.d0
GOTO 500
   64 IF(I.ne.1)GOTO 73
   76 A (1) = - 1.d0
C (1) = 0.
W (1) = 0.
GOTO 500
   73 IF(I.gt.2)GOTO 82
   81 BOB = - C1
GOTO 500
   82 BOB = 0.d0
GOTO 500
   66 IF(I.ne.1)GOTO 83
   84 A (1) = - (X (2) - X (1) ) / 3.d0
C (1) = 0.d0
W (1) = - C1 + (F (IJ + 1) - F (1) ) / (X (2) - X (1) )
GOTO 500
   83 IF(I.gt.2)GOTO 86
   85 BOB = (X (2) - X (1) ) / 6.d0
GOTO 500
   86 BOB = 0.d0
GOTO 500
   68 IF(I.ne.1)GOTO 87
   88 A (1) = - 1.d0
C (1) = 1.d0
W (1) = 0.d0
GOTO 500
   87 BOB = 0.d0
  500 ML = IOP (2)
IF(ML.eq.1)GOTO 120
IF(ML.eq.2)GOTO 130
IF(ML.eq.3)GOTO 140
IF(ML.eq.4)GOTO 150
IF(ML.eq.5)GOTO 140
  120 IF(I.ne.1)GOTO 121
  122 A (N) = 0.d0
C (N) = - 1.d0
GOTO 70
  121 BILL = 0.d0
GOTO 70
  130 IF(I.ne.1)GOTO 131
  132 A (N) = 0.d0
C (N) = - 1.d0
W (K4) = 0.
GOTO 70
  131 IF(I.ne.K)GOTO 134
  133 BILL = - C2
GOTO 70
  134 BILL = 0.d0
GOTO 70
  140 IF(I.ne.1)GOTO 141
  142 A (N) = 0.d0
C (N) = (X (N - 1) - X (N) ) / 3.d0
W (K4) = C2 - (F (K4) - F (K1) ) / (X (N) - X (N - 1) )
GOTO 70
  141 IF(I.ne.K)GOTO 143
  144 BILL = (X (N) - X (N - 1) ) / 6.d0
GOTO 70
  143 BILL = 0.d0
GOTO 70
  150 IF(I.ne.1)GOTO 151
  152 A (N) = 0.
C (N) = (X (N - 1) + X (1) - X (N) - X (2) ) / 3.d0
W (K4) = (F (IJ + 1) - F (1) ) / (X (2) - X (1) ) - (F (K4) &
 - F (K1) ) / (X (N) - X (N - 1) )
GOTO 70
  151 IF(I.ne.2)GOTO 153
  154 BILL = (X (2) - X (1) ) / 6.d0
GOTO 70
  153 IF(I.ne.K)GOTO 155
  156 BILL = (X (N) - X (N - 1) ) / 6.d0
GOTO 70
  155 BILL = 0.
GOTO 70
  100 CON = A (1) * C (N) - C (1) * A (N)
D1 = - W (1)
D2 = - W (K4)
W (1) = (D1 * C (N) - C (1) * D2) / CON
W (K4) = (A (1) * D2 - D1 * A (N) ) / CON
DO I = 2, K
   M = (I - 1) * IJ + 1
   W (M) = W (M) + A (I) * W (1) + C (I) * W (K4)
ENDDO
GOTO 305
  300 CALL ErrWrt (' SPL1D1,  N.LT.4 RESULTS INCORRECT')
  305 RETURN
END SUBROUTINE SPL1D1
SUBROUTINE SPL1D2 (N, X, F, W, IJ, Y, TAB)
USE Numeric_Kinds_Module
!***BEGIN PROLOGUE  SPL1D2
!***DATE WRITTEN   790301   (YYMMDD)
!***REVISION DATE  831207   (YYMMDD)
!***CATEGORY NO.  E1A
!***KEYWORDS  SPLINES,CUBIC SPLINES,INTERPOLATION,DERIVATIVES
!***AUTHOR  JORDAN, TOM, LOS ALAMOS NATIONAL LABORATORY
!***PURPOSE  Interpolates values of a function and its first and
!            second derivatives.
!***DESCRIPTION
!
!     SPL1D2 interpolates in a table, returning values of the function
!     and its first and second derivatives.  This is normally used
!     in conjunction with SPL1D1 which will supply second derivatives.
!
!     -ARGUMENTS-
!
!      N = integer specifying the number of points.
!      X = origin of the table of floating point values of independent
!          variable.  This table must be in ascending order.
!      F = origin of the table of floating point values of the dependent
!          variable.
!      W = origin of the table of floating point values of the second
!          derivative.  (Normally supplied through use of SPL1D1.)
!     IJ = integer specifying spacing in tables F and W.
!      Y = floating point value at which interpolation is desired.
!    TAB = array of dimension >= 3 which contains the results of the
!          interpolation.
!
!     Upon return from SPL1D2, TAB(1) contains F(Y), TAB(2) contains
!     F'(Y), and TAB(3) contains F''(Y).  There are no error messages
!     in SPL1D2.
!
!     NOTE: If Y is outside the range of the X table, extrapolation
!     occurs.
!
!     METHOD:
!
!     A complete discussion of the method may be found in the reference
!     listed below.
!
!***REFERENCES  Walsh, Ahlberg, and Nilson, Journal of Mathematics and
!                 Mechanics, Vol. II, No. 2, 1962.
!***ROUTINES CALLED  (NONE)
!***END PROLOGUE  SPL1D2
IMPLICIT NONE
INTEGER I, IJ, K1, MI, N, ilo
REAL*8 A, B, C, FLK, Y
REAL*8 X (N), F (N), W (N), TAB (3)
save ilo
!***FIRST EXECUTABLE STATEMENT  SPL1D2
!
!     LOCATE Y IN THE X TABLE
!
DATA ilo / 1 /
!
CALL FndInt (N - 1, X, Y, ilo, I)
I = MAX0 (I, 1)
MI = (I - 1) * IJ + 1
K1 = MI + IJ
FLK = X (I + 1) - X (I)
!
!     CALCULATE F(Y)
!
A = (W (MI) * (X (I + 1) - Y) **3 + W (K1) * (Y - X (I) ) **3) &
 / (6. * FLK)
B = (F (K1) / FLK - W (K1) * FLK / 6.) * (Y - X (I) )
C = (F (MI) / FLK - FLK * W (MI) / 6.) * (X (I + 1) - Y)
TAB (1) = A + B + C
!
!     CALCULATE THE FIRST DERIVATIVE AT Y
!
A = (W (K1) * (Y - X (I) ) **2 - W (MI) * (X (I + 1) - Y) **2) &
 / (2. * FLK)
B = (F (K1) - F (MI) ) / FLK
C = FLK * (W (MI) - W (K1) ) / 6.
TAB (2) = A + B + C
!
!     CALCULATE THE SECOND DERIVATIVE AT Y
!
TAB (3) = (W (MI) * (X (I + 1) - Y) + W (K1) * (Y - X (I) ) ) &
 / FLK
RETURN
END SUBROUTINE SPL1D2

Subroutine Vhamil_2AP_CIV(E_hamil,r)
USE FileUnits_Module
IMPLICIT NONE
INTEGER,parameter:: nbasis=37,nenergy=16,nbasis2=22
INTEGER icase,iupper,jupper,info
INTEGER,ALLOCATABLE::iwork(:),ifail(:)
real*8 U(nenergy,nenergy),Hamil(nbasis,nbasis)
real*8 Hamil2(nbasis,nbasis)
real*8 Hamiltemp(nbasis2,nbasis2),temp,E_hamil(nbasis)
real*8 r(3),angle,E_p,anglec,angles
real*8 v(nenergy),xab,xbc,xac,a(8),b(8)
REAL*8,ALLOCATABLE::sd(:),subd(:),vtemp(:,:)
real*8 vli2,vli2_3sig,vli2_3siu2,vli2_3piu,vli2_3pig
INTEGER i,j,k,indexi,indexj,ngri,iflag,icount
data a(1)/ 0.14535747845035D-01/
data b(1)/0.24857019396506D+00/
data a(2)/0.14946553159223D-02/
data b(2)/0.74292801158851D-01 /
data a(3)/0.73180454277552D-03/
data b(3)/0.75185999079706D-01 /
data a(4)/0.0d0 /
data b(4)/1.0d0 /
data a(5)/0.0d0 /
data b(5)/1.0d0 /
data a(6)/0.0d0 /
data b(6)/1.0d0 /
data a(7)/0.0d0 /
data b(7)/1.0d0 /
data a(8)/0.25323569592969D+00 /
data b(8)/0.74167570269811D+00 /


!---------------------------------------------------------------
!this routine is written for the diabatic potential
!It is written by Xuan LI
!Contact : XUANLI@OU.EDU
!--------------------------------------------------------
!iflag=1  !for my potential
!iflag=2  !for Daniel Brue's program
!IFLAG=3 ! use mc input files: from molpro
!IFLAG=4 ! use Boss' spk data for 16 states
IFLAG=5 !use BOSS's SPK spdf data to get A' states
xab=r(1)
xbc=r(2)
xac=r(3)
Hamil=0.0d0
Hamiltemp=0.0d0






!--------------------------------------------------------------
!define the energy for XY diatom
!E1=3sigma_u^+
!E2=3sigma_g^+(sz case)
!E3=3sigma_u^+(sz case)
!E4=E5=3pi_g^+
!E6=E7=3pi_u^+
!-------------------------------------------------------------
!warning! there are 10 basis, however in each diatom we use 7 out of them,
! so be careful with the basis, the Hamiltonian is constructed as 10x10
! then we reduce it to 7x7 without the A'' states
!-----------------------------------------------
!basis notation
! |1> =sss
! |2> =ssx
! |3> =ssy
! |4> =ssz
! |5> =sxs
! |6> =sys
! |7> =szs
! |8> =xss
! |9> =yss
! |10>=zss
!----------------------------------------------


!---------------------------------------------
!cosntruc h(m,m')_A+h(m,m')_B+h(m,m')_C
 IF(IFLAG.eq.5)E_p=(0.19603613d0-0.12834886d0)
 Hamil(1,1)= 0.0d0
 Hamil(2,2)= -E_p
 Hamil(3,3)= -E_p
 Hamil(4,4)= -E_p
 Hamil(5,5)= -E_p
 Hamil(6,6)= -E_p
 Hamil(7,7)= -E_p
 Hamil(8,8)= -E_p
 Hamil(9,9)= -E_p
 Hamil(10,10)= -E_p
 DO i=11,nbasis
 HAMIL(i,i)=-2*E_p
 ENDDO
!-----------------------------------------------
!now add the h(m,m')_AB
!-----------------------------------------------
IF(IFLAG.eq.4.or.IFLAG.eq.5)THEN
!call pot16(xab,1,v(1))
!USE Flavio's codes
v(1)=vli2(xab)
call pot16(xab,2,v(2))
call pot16(xab,3,v(3))
call pot16(xab,4,v(4))
v(5)=v(4)
call pot16(xab,6,v(6))
v(7)=v(6)
call pot16(xab,8,v(8))
call pot16(xab,9,v(9))
call pot16(xab,10,v(10))
v(11)=v(10)
call pot16(xab,12,v(12))
call pot16(xab,13,v(13))
v(14)=v(13)
call pot16(xab,15,v(15))
v(16)=v(15)
ELSE
stop 'wrong FLAG'
ENDIF



!rotational angles
! c for cos
! s for sin
    anglec=(xac*xac-xab*xab-xbc*xbc)/(2.0d0*xab*xbc)
    IF(abs(anglec-1.0d0).le.1D-10)THEN
    angles=0.0d0
    anglec=1.0d0
    ELSE
    angles=sqrt(abs(1.0000000d0-anglec*anglec))
    ENDIF

     call U_matrix_2(nbasis,nenergy,U,1,anglec,angles,xab,a,b)

hamil2=0.0d0
indexi=0
DO i=1,nbasis
    IF(i.eq.1.or.(i.ge.5.and.i.le.10).or.(i.ge.29))THEN
      indexi=indexi+1
      indexj=0
      DO j=1,nbasis
         IF(j.eq.1.or.(j.ge.5.and.j.le.10).or.(j.ge.29))THEN
         indexj=indexj+1
         temp=0.0d0
            DO k=1,nenergy
              temp=temp+v(k)*U(indexi,k)*U(indexj,k)
            ENDDO
         Hamil2(i,j)=temp
          ENDIF
      ENDDO
    ENDIF
ENDDO
   DO i=2,4
    Hamil2(i,i)=HAMIL2(1,1)
   ENDDO
   DO i=11,13
    Hamil2(i,i)=HAMIL2(5,5)
   ENDDO
   DO i=14,16
    Hamil2(i,i)=HAMIL2(6,6)
   ENDDO
   DO i=17,19
    Hamil2(i,i)=HAMIL2(7,7)
   ENDDO
   DO i=20,22
    Hamil2(i,i)=HAMIL2(8,8)
   ENDDO
   DO i=23,25
    Hamil2(i,i)=HAMIL2(9,9)
   ENDDO
   DO i=26,28
    Hamil2(i,i)=HAMIL2(10,10)
   ENDDO

   DO i=1,nbasis
     DO j=1,nbasis
       HAMIL(i,j)=HAMIL(i,j)+HAMIL2(i,j)
     ENDDO
   ENDDO
!-----------------------------------------------
!now add the h(m,m')_BC
!-----------------------------------------------

IF(iflag.eq.4.or.iflag.eq.5)THEN
!call pot16(xbc,1,v(1))
!USE Flavio's codes
v(1)=vli2(xbc)
call pot16(xbc,2,v(2))
call pot16(xbc,3,v(3))
call pot16(xbc,4,v(4))
v(5)=v(4)
call pot16(xbc,6,v(6))
v(7)=v(6)
call pot16(xbc,8,v(8))
call pot16(xbc,9,v(9))
call pot16(xbc,10,v(10))
v(11)=v(10)
call pot16(xbc,12,v(12))
call pot16(xbc,13,v(13))
v(14)=v(13)
call pot16(xbc,15,v(15))
v(16)=v(15)
ELSE
stop 'wrong FLAG'
ENDIF


    call U_matrix_2(nbasis,nenergy,U,2,0.0d0,0.0d0,xbc,a,b)
hamil2=0.0d0
indexi=0
DO i=1,nbasis
    IF((i.ge.1.and.i.le.7).or.(i.ge.11.and.i.le.19))THEN
      indexi=indexi+1
      indexj=0
      DO j=1,nbasis
         IF((j.ge.1.and.j.le.7).or.(j.ge.11.and.j.le.19))THEN
         indexj=indexj+1
         temp=0.0d0
            DO k=1,nenergy
              temp=temp+v(k)*U(indexi,k)*U(indexj,k)
            ENDDO
         Hamil2(i,j)=temp
          ENDIF
      ENDDO
    ENDIF
ENDDO

   DO i=8,10
    Hamil2(i,i)=HAMIL2(1,1)
   ENDDO
   DO i=20,26,3
    Hamil2(i,i)=HAMIL2(2,2)
   ENDDO
   DO i=21,27,3
    Hamil2(i,i)=HAMIL2(3,3)
   ENDDO
   DO i=22,28,3
    Hamil2(i,i)=HAMIL2(4,4)
   ENDDO
   DO i=29,35,3
    Hamil2(i,i)=HAMIL2(5,5)
   ENDDO
   DO i=30,36,3
    Hamil2(i,i)=HAMIL2(6,6)
   ENDDO
   DO i=31,37,3
    Hamil2(i,i)=HAMIL2(7,7)
   ENDDO

   DO i=1,nbasis
     DO j=1,nbasis
       HAMIL(i,j)=HAMIL(i,j)+HAMIL2(i,j)
     ENDDO
   ENDDO
!-----------------------------------------------
!now add the h(m,m')_AC
!-----------------------------------------------
IF(iflag.eq.4.or.iflag.eq.5)THEN
!call pot16(xac,1,v(1))
!USE Flavio's codes
v(1)=vli2(xac)
call pot16(xac,2,v(2))
call pot16(xac,3,v(3))
call pot16(xac,4,v(4))
v(5)=v(4)
call pot16(xac,6,v(6))
v(7)=v(6)
call pot16(xac,8,v(8))
call pot16(xac,9,v(9))
call pot16(xac,10,v(10))
v(11)=v(10)
call pot16(xac,12,v(12))
call pot16(xac,13,v(13))
v(14)=v(13)
call pot16(xac,15,v(15))
v(16)=v(15)
ELSE
stop 'wrong FLAG'
ENDIF

    anglec=(-xab*xab+xbc*xbc+xac*xac)/(2.0d0*xac*xbc)
    IF(abs(anglec-1.0d0).le.1D-10)THEN
    angles=0.0d0
    ELSE
    angles=sqrt(abs(1.0000000d0-anglec*anglec))
    ENDIF
    call U_matrix_2(nbasis,nenergy,U,3,anglec,angles,xac,a,b)

hamil2=0.0d0
indexi=0
DO i=1,nbasis
    IF((i.ge.1.and.i.le.4).or.(i.ge.8.and.i.le.10).or.(i.ge.20.and.i.le.28))THEN
      indexi=indexi+1
      indexj=0
      DO j=1,nbasis
         IF((j.ge.1.and.j.le.4).or.(j.ge.8.and.j.le.10).or.(j.ge.20.and.j.le.28))THEN
         indexj=indexj+1
         temp=0.0d0
            DO k=1,nenergy
              temp=temp+v(k)*U(indexi,k)*U(indexj,k)
            ENDDO
         Hamil2(i,j)=temp
          ENDIF
      ENDDO
    ENDIF
ENDDO

   DO i=5,7
    Hamil2(i,i)=HAMIL2(1,1)
   ENDDO
   DO i=11,17,3
    Hamil2(i,i)=HAMIL2(2,2)
   ENDDO
   DO i=12,18,3
    Hamil2(i,i)=HAMIL2(3,3)
   ENDDO
   DO i=13,19,3
    Hamil2(i,i)=HAMIL2(4,4)
   ENDDO
   DO i=29,31
    Hamil2(i,i)=HAMIL2(8,8)
   ENDDO
   DO i=32,34
    Hamil2(i,i)=HAMIL2(9,9)
   ENDDO
   DO i=35,37
    Hamil2(i,i)=HAMIL2(10,10)
   ENDDO

     DO i=1,nbasis
     DO j=1,nbasis
       HAMIL(i,j)=HAMIL(i,j)+HAMIL2(i,j)
     ENDDO
   ENDDO

299 FORMAT(E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x)
145 CONTINUE
!-------------------------------------------------------------
!now diagonalize the Hamil to get the potential
!-------------------------------------------------------------
!first, pick out the 22x22 submatrix


indexi=0
DO i=1,nbasis

   indexj=0
 IF(i.ne.3.and.i.ne.6.and.i.ne.9.and.i.ne.12.and.i.ne.18.and.i.ne.21.and.i.ne.23.and.i.ne.16)THEN
 IF(i.ne.25.and.i.ne.27.and.i.ne.30.and.i.ne.32.and.i.ne.34.and.i.ne.36.and.i.ne.14)THEN
   indexi=indexi+1
   DO j=1,nbasis
   IF(j.ne.3.and.j.ne.6.and.j.ne.9.and.j.ne.12.and.j.ne.18.and.j.ne.21.and.j.ne.23.and.j.ne.16)THEN
    IF(j.ne.25.and.j.ne.27.and.j.ne.30.and.j.ne.32.and.j.ne.34.and.j.ne.36.and.j.ne.14)THEN
     indexj=indexj+1
     HAMILtemp(indexi,indexj)=hamil(i,j)
    ENDIF
   ENDIF
   ENDDO
  ENDIF
  ENDIF
ENDDO
     

298 FORMAT(E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x)
297 FORMAT(7(E11.5,1x))

ngri=nbasis2
k=0


ALLOCATE(sd(ngri*(ngri+1)/2))
DO  j=1,ngri
   DO  i=j,ngri
      k=k+1
      sd(k)=Hamiltemp(i,j)
   ENDDO
ENDDO


Hamiltemp=0.0d0


iupper=min(4000,ngri)        !iupper is the upper limit of the output eigenvalue numbers
jupper=iupper
ALLOCATE(vtemp(ngri,ngri))
ALLOCATE(subd(8*ngri),iwork(5*ngri),ifail(ngri))

CALL dspevx('V','I','L',ngri,sd,0.d0,0.d0,1,iupper,0.0d-12,jupper,E_hamil,vtemp,ngri,subd,iwork,ifail,info)

DEALLOCATE(sd)
DEALLOCATE(subd,iwork,ifail,vtemp)
return

END Subroutine

Subroutine U_matrix_2(nbasis,nenergy,U,icase,anglec,angles,r,a,b)
IMPLICIT NONE
INTEGER nbasis,nenergy,icase
real*8 U(nenergy,nenergy),Rmatrix(nenergy,nenergy),npower
real*8 Pmatrix(nenergy,nenergy),Gmatrix(nenergy,nenergy)
real*8 Cmatrix(nenergy,nenergy),Mtemp(nenergy,nenergy),Tmatrix(nenergy,nenergy)
INTEGER i,j,k
real*8 angle,anglec,angles,temp,r,a(8),b(8),phi,phic,phis,phi2
real*8 anglec2,angles2,angleM,temp2,temp3
REAL*8 CTEMP1(4,4),Ctemp2(4,4),ctemp(4,4)
LOGICAL DEBUG
data DEBUG /.FALSE./
data npower /2d0/
!--------------------------------------------------------------
!define the basis
! |1> =ss
! |2> =sx
! |3> =sy
! |4> =sz
! |5> =xs
! |6> =ys
! |7> =zs
! |8> =xx
! |9> =xy
! |10> =xz
! |11> =yx
! |12> =yy
! |13> =yz
! |14> =zx
! |15> =zy
! |16> =zz
!--------------------------------------------------------------
!--------------------------------------------------------------
!define the energy for XY diatom
!E1=3sigma_u^+
!E2=3sigma_g^+(sz case)
!E3=2 3sigma_u^+(sz case)
!E4=E5=3pi_g
!E6=E7=3pi_u
!E8=3 3sigma_u^+
!E9=3sigma_g^-
!E10=E11=2 3pi_g
!E12=4 3sigma_u^+
!E13=E14=2 3pi_u
!E15=E16=3delta_u
!--------------------------------------------------------------
!U=R*P*T*G*C
!in the triplet Li case
!--------------------------------------------------------------
IF(icase.eq.1)THEN
!--------------------------------------------------------------
!we do the AB case
!--------------------------------------------------------------
anglec2=anglec*anglec
angles2=angles*angles
angleM=angles*anglec
Rmatrix=0.0d0
Rmatrix(1,1)=1.0d0
Rmatrix(2,2)=anglec
Rmatrix(2,4)=angles
Rmatrix(3,3)=1.0d0
Rmatrix(4,2)=-angles
Rmatrix(4,4)=anglec
Rmatrix(5,5)=anglec
Rmatrix(5,7)=angles
Rmatrix(6,6)=1.0d0
Rmatrix(7,5)=-angles
Rmatrix(7,7)=anglec
Rmatrix(8,8)=anglec2
Rmatrix(8,10)=angleM
Rmatrix(8,14)=angleM
Rmatrix(8,16)=angles2
Rmatrix(9,9)=anglec
Rmatrix(9,15)=angles
Rmatrix(10,8)=-angleM
Rmatrix(10,10)=anglec2
Rmatrix(10,14)=-angles2
Rmatrix(10,16)=angleM
Rmatrix(11,11)=anglec
Rmatrix(11,13)=angles
Rmatrix(12,12)=1.0d0
Rmatrix(13,11)=-angles
Rmatrix(13,13)=anglec
Rmatrix(14,8)=-angleM
Rmatrix(14,10)=-angles2
Rmatrix(14,14)=anglec2
Rmatrix(14,16)=angleM
Rmatrix(15,9)=-angles
Rmatrix(15,15)=anglec
Rmatrix(16,8)=angles2
Rmatrix(16,10)=-angleM
Rmatrix(16,14)=-angleM
Rmatrix(16,16)=anglec2



u=Rmatrix
!CHECK
!write(154,*)'Rmatrix'
298 FORMAT(E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x,E8.2,1x)
!----------------------------------
! test for Umatrix
!---------------------------------
IF(DEBUG)THEN
DO i=1,nenergy
   DO j=1,nenergy
      temp=0.0d0
      DO k=1,nenergy
      temp=temp+U(k,i)*U(k,j)
      ENDDO
      IF(i.eq.j)THEN
           IF(abs(temp-1.0d0).gt.1.0d-8)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 1'
           ENDIF
      ELSE
           IF(abs(temp).gt.1.0d-8)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 1'
           ENDIF
      ENDIF
   ENDDO
ENDDO
ENDIF
!---------------------------------------------------------------
Pmatrix=0.0d0
temp=1.0d0/sqrt(2.0d0)
Pmatrix(1,1)=1.d0
Pmatrix(2,2)=-temp
Pmatrix(2,4)=temp
Pmatrix(3,2)=-temp
Pmatrix(3,4)=-temp
Pmatrix(4,3)=1.0d0
Pmatrix(5,5)=-temp
Pmatrix(5,7)=temp
Pmatrix(6,5)=-temp
Pmatrix(6,7)=-temp
Pmatrix(7,6)=1.0d0

Pmatrix(8,8)=0.5d0
Pmatrix(8,10)=-0.5d0
Pmatrix(8,14)=-0.5d0
Pmatrix(8,16)=0.5d0
Pmatrix(9,8)=0.5d0
Pmatrix(9,10)=0.5d0
Pmatrix(9,14)=-0.5d0
Pmatrix(9,16)=-0.5d0
Pmatrix(10,9)=-temp
Pmatrix(10,15)=temp
Pmatrix(11,8)=0.5d0
Pmatrix(11,10)=-0.5d0
Pmatrix(11,14)=0.5d0
Pmatrix(11,16)=-0.5d0
Pmatrix(12,8)=0.5d0
Pmatrix(12,10)=0.5d0
Pmatrix(12,14)=0.5d0
Pmatrix(12,16)=0.5d0
Pmatrix(13,9)=-temp
Pmatrix(13,15)=-temp
Pmatrix(14,11)=-temp
Pmatrix(14,13)=temp
Pmatrix(15,11)=-temp
Pmatrix(15,13)=-temp
Pmatrix(16,12)=1.0d0


u=matmul(Rmatrix,Pmatrix)
MTEMP=u
!write(154,*)'Pmatrix'
!DO i=1,7
!write(154,298)(Pmatrix(i,j),j=1,7)
!ENDDO
!----------------------------------
! test for Umatrix
!---------------------------------
IF(DEBUG)THEn
DO i=1,nenergy
   DO j=1,nenergy
      temp=0.0d0
      DO k=1,nenergy
      temp=temp+U(k,i)*U(k,j)
      ENDDO
      IF(i.eq.j)THEN
           IF(abs(temp-1.0d0).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 2'
           ENDIF
      ELSE
           IF(abs(temp).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 2'
           ENDIF
      ENDIF
   ENDDO
ENDDO
ENDIF

!--------------------------------------------
!T matrix
Tmatrix=0.0d0
DO i=1,7
Tmatrix(i,i)=1.0d0
ENDDO
temp=1.0d0/sqrt(2.0d0)
temp2=1.0d0/sqrt(3.0d0)
temp3=1.0d0/sqrt(6.0d0)

Tmatrix(8,15)=1.0d0
Tmatrix(9,10)=temp
Tmatrix(9,13)=temp
Tmatrix(10,8)=temp2
Tmatrix(10,9)=temp
Tmatrix(10,12)=temp3
Tmatrix(11,10)=-temp
Tmatrix(11,13)=temp
Tmatrix(12,8)=-temp2
Tmatrix(12,12)=sqrt(2d0/3d0)
Tmatrix(13,11)=temp
Tmatrix(13,14)=temp
Tmatrix(14,8)=temp2
Tmatrix(14,9)=-temp
Tmatrix(14,12)=temp3
Tmatrix(15,11)=-temp
Tmatrix(15,14)=temp
Tmatrix(16,16)=1.0d0

u=matmul(MTEMP,Tmatrix)
Mtemp=u
!---------------------------------------------------------------
Gmatrix=0.0d0
Gmatrix(1,1)=1.d0
Gmatrix(2,4)=temp
Gmatrix(2,6)=-temp
Gmatrix(3,2)=temp
Gmatrix(3,3)=-temp
Gmatrix(4,5)=temp
Gmatrix(4,7)=-temp
Gmatrix(5,4)=temp
Gmatrix(5,6)=temp
Gmatrix(6,2)=temp
Gmatrix(6,3)=temp
Gmatrix(7,5)=temp
Gmatrix(7,7)=temp

DO i=8,nenergy
Gmatrix(i,i)=1.0d0
ENDDO


u=matmul(Mtemp,Gmatrix)
Mtemp=u
!write(154,*)'Gmatrix'
!DO i=1,7
!write(154,298)(Gmatrix(i,j),j=1,7)
!ENDDO
!----------------------------------
! test for Umatrix
!---------------------------------
IF(DEBUG)THEN
DO i=1,nenergy
   DO j=1,nenergy
      temp=0.0d0
      DO k=1,nenergy
      temp=temp+U(k,i)*U(k,j)
      ENDDO
      IF(i.eq.j)THEN
           IF(abs(temp-1.0d0).gt.1.0d-8)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 3'
           ENDIF
      ELSE
           IF(abs(temp).gt.1.0d-8)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 3'
           ENDIF
      ENDIF
   ENDDO
ENDDO
ENDIF

!--------------------------------------------------------------


!1,3 states are both 3sigma_u^+ so they mix
IF(abs(a(1)).lt.1d-10.or.abs(exp(b(1)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(1)*r**(npower))*exp(b(1)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP1=0.0d0
CTEMP1(1,1)=phic
CTEMP1(1,2)=phis
CTEMP1(2,1)=-phis
CTEMP1(2,2)=phic
CTEMP1(3,3)=1.0d0
CTEMP1(4,4)=1.0d0

IF(abs(a(2)).lt.1d-10.or.abs(exp(b(2)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(2)*r**(npower))*exp(b(2)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(1,1)=phic
CTEMP2(1,3)=phis
CTEMP2(3,1)=-phis
CTEMP2(3,3)=phic
CTEMP2(2,2)=1.0d0
CTEMP2(4,4)=1.0d0


CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp
IF(abs(a(3)).lt.1d-10.or.abs(exp(b(3)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(3)*r**(npower))*exp(b(3)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(1,1)=phic
CTEMP2(1,4)=phis
CTEMP2(4,1)=-phis
CTEMP2(4,4)=phic
CTEMP2(2,2)=1.0d0
CTEMP2(3,3)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(4)).lt.1d-10.or.abs(exp(b(4)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(4)*r**(npower))*exp(b(4)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(2,2)=phic
CTEMP2(2,3)=phis
CTEMP2(3,2)=-phis
CTEMP2(3,3)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(4,4)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(5)).lt.1d-10.or.abs(exp(b(5)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(5)*r**(npower))*exp(b(5)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(2,2)=phic
CTEMP2(2,4)=phis
CTEMP2(4,2)=-phis
CTEMP2(4,4)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(3,3)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(6)).lt.1d-10.or.abs(exp(b(6)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(6)*r**(npower))*exp(b(6)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(3,3)=phic
CTEMP2(3,4)=phis
CTEMP2(4,3)=-phis
CTEMP2(4,4)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(2,2)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)



CMATRIX=0.0d0
CMATRIX(1,1)=CTEMP(1,1)
CMATRIX(1,3)=CTEMP(1,2)
CMATRIX(1,8)=CTEMP(1,3)
CMATRIX(1,12)=CTEMP(1,4)
CMATRIX(3,1)=CTEMP(2,1)
CMATRIX(3,3)=CTEMP(2,2)
CMATRIX(3,8)=CTEMP(2,3)
CMATRIX(3,12)=CTEMP(2,4)
CMATRIX(8,1)=CTEMP(3,1)
CMATRIX(8,3)=CTEMP(3,2)
CMATRIX(8,8)=CTEMP(3,3)
CMATRIX(8,12)=CTEMP(3,4)
CMATRIX(12,1)=CTEMP(4,1)
CMATRIX(12,3)=CTEMP(4,2)
CMATRIX(12,8)=CTEMP(4,3)
CMATRIX(12,12)=CTEMP(4,4)

!Pi_g coupling
IF(abs(a(7)).lt.1d-10.or.abs(exp(b(7)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(7)*r**(npower))*exp(b(7)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CMATRIX(4,4)=phic
CMATRIX(4,10)=phis
CMATRIX(5,5)=phic
CMATRIX(5,11)=-phis
CMATRIX(10,4)=-phis
CMATRIX(10,10)=phic
CMATRIX(11,5)=phis
CMATRIX(11,11)=phic

!Pi_u coupling
IF(abs(a(8)).lt.1d-10.or.abs(exp(b(8)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(8)*r**(npower))*exp(b(8)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF


CMATRIX(6,6)=phic
CMATRIX(6,13)=phis
CMATRIX(13,6)=-phis
CMATRIX(13,13)=phic
CMATRIX(7,7)=phic
CMATRIX(7,14)=-phis
CMATRIX(14,7)=phis
CMATRIX(14,14)=phic

CMATRIX(2,2)=1.0d0
CMATRIX(9,9)=1.0d0
CMATRIX(15,15)=1.0d0
CMATRIX(16,16)=1.0d0

IF(DEBUG)THEN
DO i=1,nenergy
DO j=1,nenergy
!IF(i.eq.j.and.abs(CMATRIX(i,j)-1.0d0).gt.1d-8)THEN
!print*,'I,I=',i,j,CMATRIX(i,j)
!ELSEIF(i.ne.j.and.abs(CMATRIX(i,j).gt.1d-8))THEN
!print*,'I,J=',i,j,CMATRIX(i,j)
!ENDIF
ENDDO
ENDDO
ENDIF

u=matmul(Mtemp,Cmatrix)
!write(154,*)'Umatrix'
!DO i=1,7
!write(154,298)(U(i,j),j=1,7)
!ENDDO
!stop
!print*,'U=',u
!print*,'before test1'
!----------------------------------
! test for Umatrix
!---------------------------------
IF(DEBUG)THEN
DO i=1,nenergy
   DO j=1,nenergy
      temp=0.0d0
      DO k=1,nenergy
      temp=temp+U(k,i)*U(k,j)
      ENDDO
!      print*,'i,j',i,j,temp
      IF(i.eq.j)THEN
           IF(abs(temp-1.0d0).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 4'
           ENDIF
      ELSE
           IF(abs(temp).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 4'
           ENDIF
      ENDIF
   ENDDO
ENDDO
print*,'Umatrix check is done'
!stop
ENDIF

ELSEIF(icase.eq.2)THEN
!--------------------------------------------------------------
!we do the BC case
!--------------------------------------------------------------
Pmatrix=0.0d0
temp=1.0d0/sqrt(2.0d0)
Pmatrix(1,1)=1.d0
Pmatrix(2,2)=-temp
Pmatrix(2,4)=temp
Pmatrix(3,2)=-temp
Pmatrix(3,4)=-temp
Pmatrix(4,3)=1.0d0
Pmatrix(5,5)=-temp
Pmatrix(5,7)=temp
Pmatrix(6,5)=-temp
Pmatrix(6,7)=-temp
Pmatrix(7,6)=1.0d0
Pmatrix(8,8)=0.5d0
Pmatrix(8,10)=-0.5d0
Pmatrix(8,14)=-0.5d0
Pmatrix(8,16)=0.5d0
Pmatrix(9,8)=0.5d0
Pmatrix(9,10)=0.5d0
Pmatrix(9,14)=-0.5d0
Pmatrix(9,16)=-0.5d0
Pmatrix(10,9)=-temp
Pmatrix(10,15)=temp
Pmatrix(11,8)=0.5d0
Pmatrix(11,10)=-0.5d0
Pmatrix(11,14)=0.5d0
Pmatrix(11,16)=-0.5d0
Pmatrix(12,8)=0.5d0
Pmatrix(12,10)=0.5d0
Pmatrix(12,14)=0.5d0
Pmatrix(12,16)=0.5d0
Pmatrix(13,9)=-temp
Pmatrix(13,15)=-temp
Pmatrix(14,11)=-temp
Pmatrix(14,13)=temp
Pmatrix(15,11)=-temp
Pmatrix(15,13)=-temp
Pmatrix(16,12)=1.0d0
!--------------------------------------------
!T matrix
Tmatrix=0.0d0
DO i=1,7
Tmatrix(i,i)=1.0d0
ENDDO
temp=1.0d0/sqrt(2.0d0)
temp2=1.0d0/sqrt(3.0d0)
temp3=1.0d0/sqrt(6.0d0)

Tmatrix(8,15)=1.0d0
Tmatrix(9,10)=temp
Tmatrix(9,13)=temp
Tmatrix(10,8)=temp2
Tmatrix(10,9)=temp
Tmatrix(10,12)=temp3
Tmatrix(11,10)=-temp
Tmatrix(11,13)=temp
Tmatrix(12,8)=-temp2
Tmatrix(12,12)=sqrt(2d0/3d0)
Tmatrix(13,11)=temp
Tmatrix(13,14)=temp
Tmatrix(14,8)=temp2
Tmatrix(14,9)=-temp
Tmatrix(14,12)=temp3
Tmatrix(15,11)=-temp
Tmatrix(15,14)=temp
Tmatrix(16,16)=1.0d0

u=matmul(PMATRIX,Tmatrix)
Mtemp=u





!---------------------------------------------------------------
Gmatrix=0.0d0
Gmatrix(1,1)=1.d0
Gmatrix(2,4)=temp
Gmatrix(2,6)=-temp
Gmatrix(3,2)=temp
Gmatrix(3,3)=-temp
Gmatrix(4,5)=temp
Gmatrix(4,7)=-temp
Gmatrix(5,4)=temp
Gmatrix(5,6)=temp
Gmatrix(6,2)=temp
Gmatrix(6,3)=temp
Gmatrix(7,5)=temp
Gmatrix(7,7)=temp
DO i=8,nenergy
Gmatrix(i,i)=1.0d0
ENDDO

u=matmul(Mtemp,Gmatrix)
Mtemp=u
!--------------------------------------------------------------
Cmatrix=0.0d0
!1,3 states are both 3sigma_u^+ so they mix
IF(abs(a(1)).lt.1d-10.or.abs(exp(b(1)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(1)*r**(npower))*exp(b(1)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP1=0.0d0
CTEMP1(1,1)=phic
CTEMP1(1,2)=phis
CTEMP1(2,1)=-phis
CTEMP1(2,2)=phic
CTEMP1(3,3)=1.0d0
CTEMP1(4,4)=1.0d0

IF(abs(a(2)).lt.1d-10.or.abs(exp(b(2)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(2)*r**(npower))*exp(b(2)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(1,1)=phic
CTEMP2(1,3)=phis
CTEMP2(3,1)=-phis
CTEMP2(3,3)=phic
CTEMP2(2,2)=1.0d0
CTEMP2(4,4)=1.0d0


CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp
IF(abs(a(3)).lt.1d-10.or.abs(exp(b(3)*r)).gt.1d20)THEN

phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(3)*r**(npower))*exp(b(3)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(1,1)=phic
CTEMP2(1,4)=phis
CTEMP2(4,1)=-phis
CTEMP2(4,4)=phic
CTEMP2(2,2)=1.0d0
CTEMP2(3,3)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(4)).lt.1d-10.or.abs(exp(b(4)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(4)*r**(npower))*exp(b(4)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(2,2)=phic
CTEMP2(2,3)=phis
CTEMP2(3,2)=-phis
CTEMP2(3,3)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(4,4)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(5)).lt.1d-10.or.abs(exp(b(5)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(5)*r**(npower))*exp(b(5)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(2,2)=phic
CTEMP2(2,4)=phis
CTEMP2(4,2)=-phis
CTEMP2(4,4)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(3,3)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(6)).lt.1d-10.or.abs(exp(b(6)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(6)*r**(npower))*exp(b(6)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(3,3)=phic
CTEMP2(3,4)=phis
CTEMP2(4,3)=-phis
CTEMP2(4,4)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(2,2)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)

CMATRIX=0.0d0
CMATRIX(1,1)=CTEMP(1,1)
CMATRIX(1,3)=CTEMP(1,2)
CMATRIX(1,8)=CTEMP(1,3)
CMATRIX(1,12)=CTEMP(1,4)
CMATRIX(3,1)=CTEMP(2,1)
CMATRIX(3,3)=CTEMP(2,2)
CMATRIX(3,8)=CTEMP(2,3)
CMATRIX(3,12)=CTEMP(2,4)
CMATRIX(8,1)=CTEMP(3,1)
CMATRIX(8,3)=CTEMP(3,2)
CMATRIX(8,8)=CTEMP(3,3)
CMATRIX(8,12)=CTEMP(3,4)
CMATRIX(12,1)=CTEMP(4,1)
CMATRIX(12,3)=CTEMP(4,2)
CMATRIX(12,8)=CTEMP(4,3)
CMATRIX(12,12)=CTEMP(4,4)

!Pi_g coupling
IF(abs(a(7)).lt.1d-10.or.abs(exp(b(7)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(7)*r**(npower))*exp(b(7)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF

CMATRIX(4,4)=phic
CMATRIX(4,10)=phis
CMATRIX(5,5)=phic
CMATRIX(5,11)=-phis
CMATRIX(10,4)=-phis
CMATRIX(10,10)=phic
CMATRIX(11,5)=phis
CMATRIX(11,11)=phic

!Pi_u coupling
IF(abs(a(8)).lt.1d-10.or.abs(exp(b(8)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(8)*r**(npower))*exp(b(8)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF

CMATRIX(6,6)=phic
CMATRIX(6,13)=phis
CMATRIX(13,6)=-phis
CMATRIX(13,13)=phic
CMATRIX(7,7)=phic
CMATRIX(7,14)=-phis
CMATRIX(14,7)=phis
CMATRIX(14,14)=phic

CMATRIX(2,2)=1.0d0
CMATRIX(9,9)=1.0d0
CMATRIX(15,15)=1.0d0
CMATRIX(16,16)=1.0d0

u=matmul(Mtemp,Cmatrix)

!----------------------------------
! test for Umatrix
!---------------------------------
IF(DEBUG)THEN
DO i=1,nenergy
   DO j=1,nenergy
      temp=0.0d0
      DO k=1,nenergy
      temp=temp+U(k,i)*U(k,j)
      ENDDO
!      print*,'i,j',i,j,temp
      IF(i.eq.j)THEN
           IF(abs(temp-1.0d0).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 2_4'
           ENDIF
      ELSE
           IF(abs(temp).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 2_4'
           ENDIF
      ENDIF
   ENDDO
ENDDO
print*,'Umatrix check is done'
!stop
ENDIF

ELSEIF(icase.eq.3)THEN
!--------------------------------------------------------------
!we do the AC case
!--------------------------------------------------------------
anglec2=anglec*anglec
angles2=angles*angles
angleM=angles*anglec

Rmatrix=0.0d0
Rmatrix(1,1)=1.0d0
Rmatrix(2,2)=anglec
Rmatrix(2,4)=angles
Rmatrix(3,3)=1.0d0
Rmatrix(4,2)=-angles
Rmatrix(4,4)=anglec
Rmatrix(5,5)=anglec
Rmatrix(5,7)=angles
Rmatrix(6,6)=1.0d0
Rmatrix(7,5)=-angles
Rmatrix(7,7)=anglec
Rmatrix(8,8)=anglec2
Rmatrix(8,10)=angleM
Rmatrix(8,14)=angleM
Rmatrix(8,16)=angles2
Rmatrix(9,9)=anglec
Rmatrix(9,15)=angles
Rmatrix(10,8)=-angleM
Rmatrix(10,10)=anglec2
Rmatrix(10,14)=-angles2
Rmatrix(10,16)=angleM
Rmatrix(11,11)=anglec
Rmatrix(11,13)=angles
Rmatrix(12,12)=1.0d0
Rmatrix(13,11)=-angles
Rmatrix(13,13)=anglec
Rmatrix(14,8)=-angleM
Rmatrix(14,10)=-angles2
Rmatrix(14,14)=anglec2
Rmatrix(14,16)=angleM
Rmatrix(15,9)=-angles
Rmatrix(15,15)=anglec
Rmatrix(16,8)=angles2
Rmatrix(16,10)=-angleM
Rmatrix(16,14)=-angleM
Rmatrix(16,16)=anglec2

!---------------------------------------------------------------
Pmatrix=0.0d0
temp=1.0d0/sqrt(2.0d0)
Pmatrix(1,1)=1.d0
Pmatrix(2,2)=-temp
Pmatrix(2,4)=temp
Pmatrix(3,2)=-temp
Pmatrix(3,4)=-temp
Pmatrix(4,3)=1.0d0
Pmatrix(5,5)=-temp
Pmatrix(5,7)=temp
Pmatrix(6,5)=-temp
Pmatrix(6,7)=-temp
Pmatrix(7,6)=1.0d0
Pmatrix(8,8)=0.5d0
Pmatrix(8,10)=-0.5d0
Pmatrix(8,14)=-0.5d0
Pmatrix(8,16)=0.5d0
Pmatrix(9,8)=0.5d0
Pmatrix(9,10)=0.5d0
Pmatrix(9,14)=-0.5d0
Pmatrix(9,16)=-0.5d0
Pmatrix(10,9)=-temp
Pmatrix(10,15)=temp
Pmatrix(11,8)=0.5d0
Pmatrix(11,10)=-0.5d0
Pmatrix(11,14)=0.5d0
Pmatrix(11,16)=-0.5d0
Pmatrix(12,8)=0.5d0
Pmatrix(12,10)=0.5d0
Pmatrix(12,14)=0.5d0
Pmatrix(12,16)=0.5d0
Pmatrix(13,9)=-temp
Pmatrix(13,15)=-temp
Pmatrix(14,11)=-temp
Pmatrix(14,13)=temp
Pmatrix(15,11)=-temp
Pmatrix(15,13)=-temp
Pmatrix(16,12)=1.0d0
u=matmul(Rmatrix,Pmatrix)
Mtemp=u
!---------------------------------------------------------------
!--------------------------------------------
!T matrix
Tmatrix=0.0d0
DO i=1,7
Tmatrix(i,i)=1.0d0
ENDDO
temp=1.0d0/sqrt(2.0d0)
temp2=1.0d0/sqrt(3.0d0)
temp3=1.0d0/sqrt(6.0d0)

Tmatrix(8,15)=1.0d0
Tmatrix(9,10)=temp
Tmatrix(9,13)=temp
Tmatrix(10,8)=temp2
Tmatrix(10,9)=temp
Tmatrix(10,12)=temp3
Tmatrix(11,10)=-temp
Tmatrix(11,13)=temp
Tmatrix(12,8)=-temp2
Tmatrix(12,12)=sqrt(2d0/3d0)
Tmatrix(13,11)=temp
Tmatrix(13,14)=temp
Tmatrix(14,8)=temp2
Tmatrix(14,9)=-temp
Tmatrix(14,12)=temp3
Tmatrix(15,11)=-temp
Tmatrix(15,14)=temp
Tmatrix(16,16)=1.0d0

u=matmul(MTEMP,Tmatrix)
Mtemp=u




!---------------------------------------------------------------
Gmatrix=0.0d0
Gmatrix(1,1)=1.d0
Gmatrix(2,4)=temp
Gmatrix(2,6)=-temp
Gmatrix(3,2)=temp
Gmatrix(3,3)=-temp
Gmatrix(4,5)=temp
Gmatrix(4,7)=-temp
Gmatrix(5,4)=temp
Gmatrix(5,6)=temp
Gmatrix(6,2)=temp
Gmatrix(6,3)=temp
Gmatrix(7,5)=temp
Gmatrix(7,7)=temp
DO i=8,nenergy
Gmatrix(i,i)=1.0d0
ENDDO

u=matmul(Mtemp,Gmatrix)
Mtemp=u
!--------------------------------------------------------------
Cmatrix=0.0d0
!1,3 states are both 3sigma_u^+ so they mix
IF(abs(a(1)).lt.1d-10.or.abs(exp(b(1)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(1)*r**(npower))*exp(b(1)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP1=0.0d0
CTEMP1(1,1)=phic
CTEMP1(1,2)=phis
CTEMP1(2,1)=-phis
CTEMP1(2,2)=phic
CTEMP1(3,3)=1.0d0
CTEMP1(4,4)=1.0d0

IF(abs(a(2)).lt.1d-10.or.abs(exp(b(2)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(2)*r**(npower))*exp(b(2)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(1,1)=phic
CTEMP2(1,3)=phis
CTEMP2(3,1)=-phis
CTEMP2(3,3)=phic
CTEMP2(2,2)=1.0d0
CTEMP2(4,4)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(3)).lt.1d-10.or.abs(exp(b(3)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(3)*r**(npower))*exp(b(3)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(1,1)=phic
CTEMP2(1,4)=phis
CTEMP2(4,1)=-phis
CTEMP2(4,4)=phic
CTEMP2(2,2)=1.0d0
CTEMP2(3,3)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(4)).lt.1d-10.or.abs(exp(b(4)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(4)*r**(npower))*exp(b(4)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(2,2)=phic
CTEMP2(2,3)=phis
CTEMP2(3,2)=-phis
CTEMP2(3,3)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(4,4)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(5)).lt.1d-10.or.abs(exp(b(5)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(5)*r**(npower))*exp(b(5)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(2,2)=phic
CTEMP2(2,4)=phis
CTEMP2(4,2)=-phis
CTEMP2(4,4)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(3,3)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)
CTEMP1=Ctemp

IF(abs(a(6)).lt.1d-10.or.abs(exp(b(6)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(6)*r**(npower))*exp(b(6)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CTEMP2=0.0d0
CTEMP2(3,3)=phic
CTEMP2(3,4)=phis
CTEMP2(4,3)=-phis
CTEMP2(4,4)=phic
CTEMP2(1,1)=1.0d0
CTEMP2(2,2)=1.0d0
CTEMP=matmul(CTEMP1,CTEMP2)

CMATRIX=0.0d0
CMATRIX(1,1)=CTEMP(1,1)
CMATRIX(1,3)=CTEMP(1,2)
CMATRIX(1,8)=CTEMP(1,3)
CMATRIX(1,12)=CTEMP(1,4)
CMATRIX(3,1)=CTEMP(2,1)
CMATRIX(3,3)=CTEMP(2,2)
CMATRIX(3,8)=CTEMP(2,3)
CMATRIX(3,12)=CTEMP(2,4)
CMATRIX(8,1)=CTEMP(3,1)
CMATRIX(8,3)=CTEMP(3,2)
CMATRIX(8,8)=CTEMP(3,3)
CMATRIX(8,12)=CTEMP(3,4)
CMATRIX(12,1)=CTEMP(4,1)
CMATRIX(12,3)=CTEMP(4,2)
CMATRIX(12,8)=CTEMP(4,3)
CMATRIX(12,12)=CTEMP(4,4)

!Pi_g coupling
IF(abs(a(7)).lt.1d-10.or.abs(exp(b(7)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(7)*r**(npower))*exp(b(7)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CMATRIX(4,4)=phic
CMATRIX(4,10)=phis
CMATRIX(5,5)=phic
CMATRIX(5,11)=-phis
CMATRIX(10,4)=-phis
CMATRIX(10,10)=phic
CMATRIX(11,5)=phis
CMATRIX(11,11)=phic

!Pi_u coupling
IF(abs(a(8)).lt.1d-10.or.abs(exp(b(8)*r)).gt.1d20)THEN
phic=1.0d0
phis=0.0d0
ELSE
phi=1.0d0/(a(8)*r**(npower))*exp(b(8)*r)
phi2=phi*phi
phic=sqrt(phi2/(1.0d0+phi2))
phis=sqrt(1.0d0/(1.0d0+phi2))
ENDIF
CMATRIX(6,6)=phic
CMATRIX(6,13)=phis
CMATRIX(13,6)=-phis
CMATRIX(13,13)=phic
CMATRIX(7,7)=phic
CMATRIX(7,14)=-phis
CMATRIX(14,7)=phis
CMATRIX(14,14)=phic

CMATRIX(2,2)=1.0d0
CMATRIX(9,9)=1.0d0
CMATRIX(15,15)=1.0d0
CMATRIX(16,16)=1.0d0
u=matmul(Mtemp,Cmatrix)

!----------------------------------
! test for Umatrix
!---------------------------------
IF(DEBUG)THEN
DO i=1,nenergy
   DO j=1,nenergy
      temp=0.0d0
      DO k=1,nenergy
      temp=temp+U(k,i)*U(k,j)
      ENDDO
!      print*,'i,j',i,j,temp
      IF(i.eq.j)THEN
           IF(abs(temp-1.0d0).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 3_4'
           ENDIF
      ELSE
           IF(abs(temp).gt.1.0d-6)THEN
           print*,'wrong 2dbasis=',i,j,temp
           stop 'error 3_4'
           ENDIF
      ENDIF
   ENDDO
ENDDO
print*,'Umatrix check is done'
stop
ENDIF
ELSE
print*,'unable to do more than 3 atoms now'
stop 'Umatrix in lib'
ENDIF
return
END subroutine

    !-------------------------------------------------------------------
    ! function  : vli3_3b
    !
    ! package   : Li3 Potential
    !
    ! Language  : Fortran 77
    !
    ! author    : F. Colavecchia (flavioc@lanl.gov)
    !             G. A. Parker   (parker@nhn.ou.edu)
    !
    ! date      : 05/10/02       version: 0.1
    ! revision  :                version:
    !
    ! purpose   :  Compute the three body term of the spin aligned
    !              Li3 potential
    !
    ! input     :  r  -> interatomic distances in atomic units  
    !
    ! output    :  vli3_3b -> three body term  
    !
    ! modules   :
    !
    !
    ! common    :
    !
    !
    ! notes     :  Potential is build upon an interpolation of
    !              ab initio data for values of the scaled perimeter (s1) less
    !              than pswitch, and a extrapolation for greater values
    !              of the scaled perimeter. Asymptotic form corresponds
    !              to that of the Axilrod-Teller potential for Li3
    !              Needs: parameters.dat
    !                     li3_sc_cyclic.dat
    !                     coef_li3_sc_cyclic.dat
    !              in the inter and extrapolation routines.
    !
    !
    !
    !
    !-------------------------------------------------------------------
      real*8 function vli3_3b_at(ri)
      implicit none
      logical search,check,is_in
      integer i,num,j,ne
      integer r2s
      real*8 r(3),ri(3)      
      real*8 v,s1,s2,s3,ee,e2,rr,dummy
      real*8 pswitch,rho,vli3_at
      real*8 delper, s1switch, vinterp, vextrap
      data check /.false./
      save ne,pswitch,rr     
!      save firstcall,xe,ne,pswitch,rr
!
!     Compute the three body part of the Li3 potential
!
!     the requirement is that r(3) are in bohr atomic units
!     However, see interpolate.f
!
      vli3_3b_at = 0d0 
      r(1) = ri(1) 
      r(2) = ri(2) 
      r(3) = ri(3) 
      rho = dsqrt(dsqrt(3d0)/3d0*(r(1)**2+r(2)**2+r(3)**2))
      !
      !   get the s1,s2,s3
      !
      i = r2s(r(1),r(2),r(3),s1,s2,s3,.true.)
      !
      !   Optimal r value
      !
      rr=1.08d0
      !
      !     The triangular coordinates are defined as:
      !           
      !      s1=(r(1)+r(2)+r(3))/dsqrt(3.0d0)
      !      s2=(r(2)-r(3))/dsqrt(2.0d0)
      !      s3=(2.0d0*r(1)-r(2)-r(3))/dsqrt(6.0d0)
      !
      !
      !
      !     Here we decide between inter or extrapolation. 
      !     See paper for details
      !
      delper=0.075d0
      pswitch=25d0

      s1switch=0.5d0*(1.d0+tanh((s1-pswitch)/(pswitch*delper)))
     
      v=0d0*(1.d0-s1switch)+(vli3_at(r))*s1switch

      vli3_3b_at = v
      return
      end

SUBROUTINE POT16(r,Istate,E)
! an equivalent of subroutine POT7 ..and we have 16 states instead of 7 states
IMPLICIT NONE
real*8 r,E,tab(3),EP
INTEGER Istate,ithcall,iop(2),i
INTEGER,parameter:: nr1=51
Real*8 V(nr1,16),RV(nr1),temp
real*8 aa(nr1),bb(nr1),cc(nr1)
REAL*8 SECOND_1(nr1),SECOND_2(nr1),SECOND_3(nr1),SECOND_4(nr1),SECOND_6(nr1),shiftss,shiftsp,shiftpp
REAL*8 SECOND_8(nr1),SECOND_9(nr1),SECOND_10(nr1),SECOND_12(nr1),SECOND_13(nr1),SECOND_15(nr1)
data ithcall /0/
!NEW FCI data with a new p basis
data shiftss /-0.39207225d0/
data shiftsp /-0.32438499d0/
data shiftpp /-0.25669772d0/
data EP/0.06768727d0/
!--------------------------------------------------------------
!define the energy for XY diatom
!E1=3sigma_u^+
!E2=3sigma_g^+(sz case)
!E3=3sigma_u^+(sz case)
!E4=E5=3pi_g^+
!E6=E7=3pi_u^+
!---------------------------------------------------------------


!there are 33 lines of mcI files
IF(ithcall.eq.0)THEN
ithcall=1
!state 1,3,8,12
OPEN(unit=910,file='Potentials/WEB_LI3/3siu5.fci.table')
DO i=1,nr1
READ(910,*)RV(i),V(i,1),V(i,3),V(i,8),V(i,12)
ENDDO
CLOSE(910)

! state 2
OPEN(unit=910,file='Potentials/WEB_LI3/3sig1.fci.table')
DO i=1,nr1
READ(910,*)RV(i),V(i,2)
ENDDO
CLOSE(910)
! state (4,5),(10,11)
OPEN(unit=910,file='Potentials/WEB_LI3/3pig6.fci.table')
DO i=1,nr1
READ(910,*)RV(i),V(i,4),V(i,10)
ENDDO
CLOSE(910)

!state (6,7) and (13,14)
OPEN(unit=910,file='Potentials/WEB_LI3/3piu2.fci.table')
DO i=1,nr1
READ(910,*)RV(i),V(i,6),V(i,13)
ENDDO
CLOSE(910)

!state (15,16)
OPEN(unit=910,file='Potentials/WEB_LI3/3del8.fci.table')
DO i=1,nr1
READ(910,*)RV(i),V(i,15)
ENDDO
CLOSE(910)

!state 9
OPEN(unit=910,file='Potentials/WEB_LI3/3del4.fci.table')
DO i=1,nr1
READ(910,*)RV(i),V(i,9)
ENDDO
CLOSE(910)

CALL spl1d1 (nr1, RV(1), V(1,1), SECOND_1(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,2), SECOND_2(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,3), SECOND_3(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,4), SECOND_4(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,6), SECOND_6(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,8), SECOND_8(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,9), SECOND_9(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,10), SECOND_10(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,12), SECOND_12(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,13), SECOND_13(1), iop, 1, aa (1), bb (1), cc (1) )
CALL spl1d1 (nr1, RV(1), V(1,15), SECOND_15(1), iop, 1, aa (1), bb (1), cc (1) )
print*,'Initialization DONE'
ENDIF

IF(Istate.eq.1)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,1), SECOND_1(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,1)
ELSE
E=V(nr1,1)
ENDIF
E=E-shiftss

return
ELSEIF(Istate.eq.2)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,2), SECOND_2(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,2)
ELSE
E=V(nr1,2)
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.3)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,3), SECOND_3(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,3)
ELSE
E=V(nr1,3)
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.4)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,4), SECOND_4(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,4)
ELSE
!E=V(nr1,4)
E=EP+(V(nr1,4)-shiftss-EP)*exp(-2d0*(r-RV(nr1)))+shiftss
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.6)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,6), SECOND_6(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,6)
ELSE
!E=V(nr1,6)
E=EP+(V(nr1,6)-shiftss-EP)*exp(-2d0*(r-RV(nr1)))+shiftss
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.8)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,8), SECOND_8(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,8)
ELSE
E=V(nr1,8)
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.9)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,9), SECOND_9(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,9)
ELSE
E=V(nr1,9)
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.10)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,10), SECOND_10(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,10)
ELSE
E=V(nr1,10)
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.12)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,12), SECOND_12(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,12)
ELSE
E=V(nr1,12)
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.13)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,13), SECOND_13(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,13)
ELSE
E=V(nr1,13)
ENDIF
E=E-shiftss
return

ELSEIF(Istate.eq.15)THEN
IF(r.ge.RV(1).and.r.le.RV(nr1))THEN
CALL spl1d2 (nr1, RV(1), V(1,15), SECOND_15(1), 1, r, tab)
E=tab(1)
ELSEIF(r.lt.RV(1))THEN
E=V(1,15)
ELSE
E=V(nr1,15)
ENDIF
E=E-shiftss
return

ELSE 
stop 'WRONG istate'
ENDIF

END

SUBROUTINE surface_2AP(v,x)
IMPLICIT NONE
REAL*8 r(3),v,phi,x(3),phio,E(37),phiswitch
integer r2s
real*8 delper,s1switch,dphi,pswitch,s1,vli3_at,VF,temp
real*8 acos,tanh,v1,v2,v3b
data delper/0.075d0/
data pswitch/25d0/
data dphi/0.02d0/
data phio/2.96705972839036d0/ ! 170* degrees
save

r(1)=maxval(x)
r(3)=minval(x)
r(2)=max(min(x(1),x(2)),min(x(2),x(3)),min(x(1),x(3)))
temp=(r(2)**2+r(3)**2-r(1)**2)/(2d0*r(2)*r(3))
IF(abs(temp-1d0).lt.1d-10)THEN
phi=acos(1d0)
ELSEIF(abs(temp+1d0).lt.1d-10)THEN
phi=acos(-1d0)
ELSE
phi=acos(temp)
ENDIF


      phiswitch=0.5d0*(1.d0+tanh((phi-phio)/(phio*dphi)))

      call Vhamil_2AP_CIV(E,r)
      call TRI3B_2AP_CIV(r(1),r(2),r(3),v3b)
      IF(r(1).lt.4.0d0.and.E(1).gt.1d-2)v3b=0d0
      v1=E(2)+v3b

      call Vhamil_2AP_C2V(E,r)
      call TRI3B_2AP_C2V(r(1),r(2),r(3),v3b)
      IF(r(1).lt.4.0d0.and.E(1).gt.1d-2)v3b=0d0
      V2=E(2)+V3b

      v=v2*(1.d0-phiswitch)+v1*phiswitch

return
END      

      
